function [OrigAngs CombAngs Cent] = CentroRefFunc1E(I,BWT,Ordf)
%Author - Akila Mike
%Last Modified - MAY-2010
%This function takes in the,
%   Image - I ,
%   Binary result of the GVF snake - BWT
%   The selected neigborhood around the current centromere - Ordf
%The function then returns these variables after perfomring a local search,
%   Angle of the perpendicular line to the current centerline axis - OrigAngs
%   Search space angle set - CombAngs
%   The width profile values - Cent

%% Initialization
%CombAngs = [0 2.5 5 7.5 10 12.5 15 17.5 20 22.5 25 27.5 30 32.5 35 37.5 40 42.5 45 47.5 50 52.5 55 57.5 60 62.5 65 67.5 70 72.5 75 77.5 80 82.5 85 87.5 89 92.5 95 97.5 100 102.5 105 107.5 110 112.5 115 117.5 120 122.5 125 127.5 130 132.5 135 137.5 140 142.5 145 147.5 150 152.5 155 157.5 160 162.5 165 167.5 170 172.5 175];
%CombAngs = [0.00 1.25 2.50 3.75  5.00 6.25 7.50 8.75 10.00 11.25 12.50 13.75 15.00 16.25 17.50 18.75 20.00 21.25 22.50 23.75 25.00 26.25 27.50 28.75 30.00 31.25 32.50 33.75 35.00 36.25 37.50 40 42.5 45 47.5 50 52.5 55 57.5 60 62.5 65 67.5 70 72.5 75 77.5 80 82.5 85 87.5 89 92.5 95 97.5 100 102.5 105 107.5 110 112.5 115 117.5 120 122.5 125 127.5 130 132.5 135 137.5 140 142.5 145 147.5 150 152.5 155 157.5 160 162.5 165 167.5 170 172.5 175];
CombAngs = [0:1.25:89.5];
CombAngs = [CombAngs 89.9];
Combs = tan(CombAngs .*pi ./180);
combinations = size(CombAngs,2);
AvgL = [];
nopntside1 = 0;
nopntside2 = 0;
dividefac1 = 0;
dividefac2 = 0;
[LIL] = getinitContour(BWT);
LIf = [LIL(:,2) LIL(:,1)];
OrigAngs = [];

xvC = Ordf(:,1);
yvC = Ordf(:,2);
sizeL = size(Ordf,1);
sd1LArray = [];
sd2LArray = [];


%% Calculations of the width profiles for each side and each angle.
for m=1:sizeL-2
    nopntside1 = 0;
    nopntside2 = 0;
    avgside1 = 0;
    avgside2 = 0;    
    stp = m;
    thp = stp+1;
    stp2 = stp+2;    
    if((xvC(stp2)-xvC(stp))==0)
        OrigAngs = [OrigAngs; 0];
    elseif ((yvC(stp2)-yvC(stp))==0)
        OrigAngs = [OrigAngs; 90];
    else
        m = (yvC(stp2)-yvC(stp))/(xvC(stp2)-xvC(stp)); 
        m = -1/m;
        if (m>0)
            OrigAngs = [OrigAngs; 180*atan(m)/pi];
        else
            OrigAngs = [OrigAngs; (180 + (180*atan(m)/pi))];
        end
    end
    sdLl = zeros(1,combinations);
    sdL2 = zeros(1,combinations);   
    
    for i=1:combinations  
            m1 = Combs(i);       
            c1 = yvC(thp) - (m1*xvC(thp));
            %M and C Calculations are done...

            cryp =  yvC(thp);
            crxp =  xvC(thp);

            cryD =  yvC(thp); %Only for Drawing
            crxD =  xvC(thp); %Only for Drawing

            flag2loop = 1;
            if (abs(m1)<=1)
                xydom = 1; %X is Dominant...
            else
                xydom = 2; %Y is Dominant...
            end       
            TempX = [];
            TempY = [];
            %Another Sub Loop Should Start...For Each Side
                while(flag2loop)
                    %sd1round = sd1round+1;
                    %Side 1 - Assumming xydom = 1;
                    if(xydom == 1)              % X is Dominant
                        crx = crxp - 1;
                        cry = round((m1*crxp)+c1);

                        crxD = crx;             %For Display
                        cryD = ((m1*crxp)+c1);  %For Display
                    else                        % Y is Dominant
                        if (m1>=0)
                            cry = cryp - 1;

                            cryD = cry;         %For Display
                        else
                            cry = cryp + 1;

                            cryD = cry;         %For Display
                        end
                        crx = round((cry-c1)/m1);

                        crxD = ((cry-c1)/m1);
                    end                
                    val = BWT(cry,crx);         %Extracting Values 4m BIN IMAGE
                    if(val)                     %Only if not Zero
                        nopntside1 = nopntside1 + 1;
                        if (nopntside1>19)
                            dividefac1 = 20;
                        else
                            dividefac1 = nopntside1;
                        end
                        TempX = [TempX crxD];
                        TempY = [TempY cryD];
                        difsum = abs(crx - crxp)+ abs(cry - cryp);
                        if(difsum>1)
                            sdLl(i) = sdLl(i)+sqrt(2); 
                        else
                            sdLl(i) = sdLl(i)+1;
                        end

                    else
                        flag2loop=0;        
                    end  
                crxp = crx;
                cryp = cry;
                end
    %SECOND SIDE STARTS--------------------------->

            TempX2 = [];
            TempY2 = [];
            cryp2 =  yvC(thp);
            crxp2 =  xvC(thp);
            cryD2 =  yvC(thp); %Only for Drawing
            crxD2 =  xvC(thp); %Only for Drawing
            flag2loop2 = 1;
                while(flag2loop2)
                    if(xydom == 1) 
                        crx2 = crxp2 + 1;
                        cry2 = round((m1*crxp2)+c1);
                        crxD2 = crx2;
                        cryD2 = ((m1*crxp2)+c1);                
                    else
                        if (m1>=0)
                            cry2 = cryp2 + 1;
                            cryD2 = cry2;
                        else
                            cry2 = cryp2 - 1;
                            cryD2 = cry2;
                        end
                        crx2 = round((cry2-c1)/m1);
                        crxD2 = ((cry2-c1)/m1);
                    end
                    val = BWT(cry2,crx2);
                    if(val)
                        nopntside2 = nopntside2 + 1;
                        if (nopntside2>19)
                            dividefac2 = 20;
                        else
                            dividefac2 = nopntside2;
                        end
                        TempX2 = [TempX2 crxD2];
                        TempY2 = [TempY2 cryD2];
                        difsum2 = abs(crx2 - crxp2)+ abs(cry2 - cryp2);
                        if(difsum2>1)
                            sdL2(i) = sdL2(i)+1.432; 
                        else
                            sdL2(i) = sdL2(i)+1;
                        end
                    else
                        flag2loop2=0;        
                    end  
                crxp2 = crx2;
                cryp2 = cry2;
                end               
    end
        sd1LArray = [sd1LArray;sdLl];   
        sd2LArray = [sd2LArray;sdL2];  
end
%Loop Ends here

%% Adding both sides
sdLArray = sd1LArray + sd2LArray;
Cent = sdLArray;
%--------------------------------------------------------------------------











