function [resVal] = FISAnalysisFunc1(ResW,ResDA,ResIntL,OffsetV)
%Author - Akila Mike
%Last Modified - MAY-2010
%This function takes in the,
%   ResW - The selected width profiles
%   ResDA - Their angle difference with the perpendicular
%   ResOff - Offset from the current centromere
%Then, the function returns the best possible result for the centromere.
%This is calculated using the Fuzzy inferencing setup in 'centro.fis' file.

%% Initialization
flagmax1 = 0;   %Flag used to find out if there are more than 1 Max
flagmax2 = 0;   %Flag used to find out if there are more than 1 Max
a = readfis('centronewINT.fis');      %Loading the fuzzy setup (Rules, MFs etc.)
% whos ResW
% whos ResDA
% whos ResIntL
% whos OffsetV
Dataset = [ResW ResDA ResIntL];

ResW
ResDA
ResIntL

%pause

ResW1 = ResW(:,1);
ResW2 = ResW(:,2);
ResDA1 = ResDA(:,1);
ResDA2 = ResDA(:,2);

%% Evaluation.
Res1 = evalfis([ResW1 ResDA1 ResIntL],a)
R1Max = max(Res1)
R1MaxInd = find(Res1==R1Max)
%R1MaxIndT = (Res1==R1Max);
Res2 = evalfis([ResW2 ResDA2 ResIntL],a)
R2Max = max(Res2)
R2MaxInd = find(Res2==R2Max)
%pause
%R2MaxIndT = (Res2==R2Max);

if (length(R1MaxInd)>1)
    flagmax1 = 1
end

if (length(R2MaxInd)>1)
    flagmax2 = 1
end

%OffsetV

T1 = OffsetV(R1MaxInd)
T1max = min(T1)
T1maxind = find(OffsetV==T1max);
T1maxind = T1maxind(1)

T2 = OffsetV(R2MaxInd)
T2max = min(T2)
T2maxind = find(OffsetV==T2max);
T2maxind = T2maxind(1)


if (T1max == T2max)
    if (R1Max >= R2Max)
        disp('Solution 1 selected-SPECIAL!')
        %resVal = R1MaxInd(1);
        resVal = T1maxind
    else
        disp('Solution 2 selected-SPECIAL!')
        %resVal = R1MaxInd(1);
        resVal = T2maxind
    end
end

if (T1max > T2max)
    disp('Solution 1 selected!')
    %resVal = R1MaxInd(1);
    resVal = T1maxind
end

if (T1max < T2max)
    disp('Solution 2 selected!')
    %resVal = R2MaxInd(1);
    resVal = T2maxind
end

%pause

%pause
%--------------------------------------------------------------------------



