function [Cent,AvgInt,lineMain,lineOther,RecMidPnt,flagDiv,ptel1,ptel2,pside1,pside2,line1,line2,cont,PosSets] = MAINPROGRAMLAP2(A,imagename,corC,corR,number,thrFac,ImgScale,halfsizeR,halfsizeC,ImgType,bands,factor,figflag,foldrName)

%Author - AKILA MIKE SUBASINGHE
%This Program makes all necessary Function calls in order to detect the
%Medial Axis Accurately and to Calculate the Ratios
%Factor is the control variable
%==========================================================================
%==========================================================================
%INITIAL SET UP - START
%clear all
close all
clc

tempnumb = 1; %Meant only for saving profiles to compare later.
tempnumb = int2str(tempnumb);

%ImgType - is 0 - when DAPI, 1 - GEIMSA

center = '_xy_center_';
methods = '_Laplacian';
centerprun = '_xy_center_prunned_';
bench = '_xy_bench_';
length = '_length_';
final = '_result_';
centroPos = '_CentroPos_';
numb1 = int2str(number);
Formatt = '.txt';
Formati = '.tif';
FormatF = '.mat';

CENTRO = '_CENTRO_';
BOUND = '_BOUND_';

centername = [imagename center numb1 Formatt];
centerprunname = [imagename centerprun numb1 Formatt];
benchname = [imagename bench numb1 Formatt];
lengthname = [imagename length numb1 Formatt];
centroPosname = [imagename centroPos numb1 Formatt];

CENTROname = [imagename CENTRO numb1 Formatt] %Meant only for saving profiles to compare later.
BOUNDname = [imagename BOUND numb1 FormatF];

profiles = 'PROFILES';
Filetempnumb = [imagename profiles tempnumb FormatF]

% fidcenter = fopen(centername,'w');
% fidcenterprun = fopen(centerprunname,'w');
% fidbench = fopen(benchname,'w');
% fidlengths = fopen(lengthname,'w');
% fidcentroPos = fopen(centroPosname,'w');
% 
% fidCENTRO = fopen(CENTROname,'w');

factorVble = num2str(factor); % This is the control variable 'b'

foldn = pwd;
foldrName = [foldn '\IMAGE_RESULTS\']

finalimage = [foldrName numb1 methods factorVble Formati];
%path
%path(path,'C:/Documents and Settings/akila/My Documents/MATLAB/INTEGRATE/WITH USER INPUTS/SKELETON')
%path(path,'C:/Documents and Settings/akila/My Documents/MATLAB/INTEGRATE/WITH USER INPUTS/SNAKE')
fname1 = 'New.pgm';
%Parameters Controlling the Window SIZE..Each is Half (1/2) the actual W/H
%halfsizeR = 100;
%halfsizeC = 100;

%thrFac = 1.10;
%ImgScale = 1.00; %This value should be in nm (The Length or Width of 1 Pixel)


%__________________________________________________________________________
%JUST FOR GENERATING FILENAMES FOR THE SHAPE ANALYSIS PART.
%dataS = 'DataS';

%numb = 45;


base = 'Telo';
%xybase = 'XYSeg';
imgbase = 'IMGSeg';
imgbase2 = 'IMG';
exten = '.mat';
imgexten = '.tif';
%numb = int2str(numb);
%lname = [dataS numb];
imgname = [imgbase imgexten];
imgname2 = [imgbase2 imgexten];
num1 = '1';
num2 = '2';
% num3 = '3';
% num4 = '4';
%num1 and num2 are telomeres, num3 and num4 are sides.
savename1 = [base num1 exten];
%xysavename1 = [xybase numb num1 exten];
savename2 = [base num2 exten];
%xysavename2 = [xybase numb num2 exten];
%savename3 = [base numb num3 exten];
%xysavename3 = [xybase numb num3 exten];
%savename4 = [base numb num4 exten];
%xysavename4 = [xybase numb num4 exten];
order = 9;

%__________________________________________________________________________



%INITIAL SET UP - DONE
%==========================================================================
%==========================================================================
%IMAGE SELECTION,PRE-PROCESSING - START

% A = imread(imagename);
% szA = size(A);
% 
% if(size(szA,2)>2)
%     A = rgb2gray(A);
% end
% 
% if (ImgType==1)
% A = 255 - A;    %WHEN THE IMAGES ARE INVERTED IMAGES.
% end




% figure
% imshow(A,[])
% title('DAPI IMAGE')

%[corC,corR] = ginput(1)
minY = corR-halfsizeR;
minX = corC-halfsizeC;

COMB = imcrop(A,[minX minY (2*halfsizeR) (2*halfsizeC)]);
% figure, imshow(COMB,[])
% title('CROPPED IMAGE')

COMB = imadjust(COMB);
% figure, imshow(COMB,[])
% title('Improved CROPPED IMAGE')

%figure
%[count x] = imhist(BW);
% imhist(BW)
% title('CROPPED IMAGE HIST')
%[sizeofR sizeofC]  = size(count)
%level2 = thresholdcalc(count,x)

basel = thrFac*graythresh(COMB);
BWT = im2bw(COMB, basel);
% figure, imshow(BWT,[]) %title('BINARY IMAGE')
AT = bwselect(BWT,halfsizeR,halfsizeC,4);
% figure, imshow(AT)
% title('OBJECT SELECTED!')

ObjInd = find(AT);
Selsize = size(ObjInd,1);

if (Selsize<2)
    [AT]=myLabelObjExtract(COMB,BWT,halfsizeC,halfsizeR);
%     figure, imshow(AT)
%     title('BWN - NEW OBJECT SELECTED!')
end

%0000000000000000000000000000000000000000000
%     figure, imshow(AT)
%     title('BWN - NEW OBJECT SELECTED!')
%0000000000000000000000000000000000000000000

[FO] = myPreProcess(COMB);
imwrite(FO,fname1);


%IMAGE SELECTION,PRE-PROCESSING - DONE
%==========================================================================
%==========================================================================
%GVF SNAKE,PATH FINDING,PRUNNING - START

[I,map] = rawread(fname1);
[BW2,contourPxy] = CentreofOPS2(I,AT);

BWthin = bwmorph(BW2,'thin',Inf);
%0000000000000000000000000000000000000000000
BWskel = bwmorph(BW2,'skel',Inf);
%0000000000000000000000000000000000000000000
%[Z] = thintrace(BWthin);


%[FPath,Flength,bwx] = myBranchFinding(BW2,I);

[FPath,Flength,bwx,ptel1,ptel2,pside1,pside2,cont,PosSets,DemoFlag,StateFeatureMat] = myBranchFinding2(BW2,I,figflag,number,foldrName);


if(DemoFlag==1)
    Tpref = 'ContPart';
    TempFile = [foldrName Tpref numb1 exten]
    save(TempFile,'StateFeatureMat','BW2','I','cont','corC','corR','A','imagename','number','thrFac','ImgScale','halfsizeR','halfsizeC','ImgType','bands','factor','figflag')
    Cent = 1;
    AvgInt = 1;
    lineMain = 1;
    lineOther = 1;
    RecMidPnt = 1;
    flagDiv = 1;
    line1 = 1;
    line2 = 1;
    cont = 1;
    PosSets = 1;
    
else
    %__________________________________________________________________________
    %__________________________________________________________________________
    %JUST FOR GENERATING DATA FOR THE SHAPE ANALYSIS PART.

    SX1 = ptel1(:,2);
    SY1 = ptel1(:,1);

    SX2 = ptel2(:,2);
    SY2 = ptel2(:,1);

    SX3 = pside1(:,2);
    SY3 = pside1(:,1);

    SX4 = pside2(:,2);
    SY4 = pside2(:,1);

    % figure
    % plot(SX1,SY1,'*r')
    % hold on
    % plot(SX2,SY2,'sb')
    % hold on
    % plot(SX3,SY3,'*y')
    % hold on
    % plot(SX4,SY4,'sk')
    % hold off
    % legend('seg1-tel1','seg2-tel2','seg3-side1','seg4-side2')
    % text1 = 'Plot of segments of the chromosome';
    % title(text1)
    % saveas(gcf,imgname)

    [SX1, SY1] = rotatefunc(SX1, SY1);
    Stroke1 = [SX1, SY1];
    [coeffListX1, coeffListY1] = callinkfunc(Stroke1, order);
    x1 = coeffListX1';
    y1 = coeffListY1';
    data = [x1, y1];
    %savefile = 'Seg11.mat';
    save(savename1, 'data')
    % SX = SX1;
    % SY = SY1;
    % save(xysavename1, 'SX','SY')


    [SX2, SY2] = rotatefunc(SX2, SY2);
    Stroke1 = [SX2, SY2];
    [coeffListX1, coeffListY1] = callinkfunc(Stroke1, order);
    x2 = coeffListX1';
    y2 = coeffListY1';
    data = [x2, y2];
    %savefile = 'Seg12.mat';
    save(savename2, 'data')
    % SX = SX2;
    % SY = SY2;
    % save(xysavename2, 'SX','SY')

    % [SX3, SY3] = rotatefunc(SX3, SY3);
    % Stroke1 = [SX3, SY3];
    % [coeffListX1, coeffListY1] = callinkfunc(Stroke1, order);
    % x1 = coeffListX1';
    % y1 = coeffListY1';
    % data = [x1, y1];
    % %savefile = 'Seg13.mat';
    % save(savename3, 'data')
    % SX = SX3;
    % SY = SY3;
    % save(xysavename3, 'SX','SY')
    % 
    % [SX4, SY4] = rotatefunc(SX4, SY4);
    % Stroke1 = [SX4, SY4];
    % [coeffListX1, coeffListY1] = callinkfunc(Stroke1, order);
    % x1 = coeffListX1';
    % y1 = coeffListY1';
    % data = [x1, y1];
    % %savefile = 'Seg14.mat';
    % save(savename4, 'data')
    % SX = SX4;
    % SY = SY4;
    % save(xysavename4, 'SX','SY')

    imwrite(COMB,imgname2)




    %disp('DONE')
    %pause
    %__________________________________________________________________________
    %__________________________________________________________________________




    %0000000000000000000000000000000000000000000
    % figure
    % subplot(2,2,1); imshow(BW2,[])
    % title('Original')
    % subplot(2,2,2); imshow(bwx,[])
    % title('DCE')
    % subplot(2,2,3); imshow(BWthin,[])
    % title('Thinned')
    % subplot(2,2,4); imshow(BWskel,[])
    % title('Skeleton')

    % % imshow(BWthin,[])
    % % title('INTERESTING!!!!')
    %0000000000000000000000000000000000000000000

    %GVF SNAKE,PATH FINDING,PRUNNING - DONE
    %==========================================================================
    %==========================================================================
    %SAMPLING POINTS ON THE SKELETON - START
    %pnts = 5;
    

    %pause
    % if(intskllng<40)
    %     [Z] = thintrace(BWthin);
    %     FPath = Z;
    %     disp('HYBRID CRITERIA MET')
    % end
 
    intskllng = size(FPath,1);
    Flength = size(FPath,1);

    [fac pnts smpWidth StopFlag] = mySpacingCalc(FPath,intskllng);
    [SamP]=mySample(FPath,pnts,fac);

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    %REMOVE THE CHROMOSOME IF THE "STOPFLAG==1"

    % if (StopFlag==1)
    %     disp('TOO SHORT')
    %     return;
    % end

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    SampR = SamP(:,2);
    SampC = SamP(:,1);

    Lend = 1 + fac;
    Hend = Flength - fac;

    %whos FPath
    FPathS = FPath(Lend:Hend,:);

    %save (fname2,'FPath','I','bw2thin')
    %save(filenames, 'SamP', 'SampR','SampC','I','pnts')

    %0000000000000000000000000000000000000000000
    % figure
    % imshow(I,[])
    % hold on
    % plot(SampC,SampR,'*')
    % hold off
    %0000000000000000000000000000000000000000000

    %SAMPLING POINTS ON THE SKELETON - DONE
    %==========================================================================
    %==========================================================================
    %SAMPLING POINTS ON SPLINE FIT - START

    % -------------------------------------------------------------------------
    % COMMENTED - To REMOVE SPLINE - Replaced by LAPLACIAN APPROACH------------
    % -------------------------------------------------------------------------

    % [OrdfillInt,spnts2] = SplineTempMine2XY(I,SamP,FPathS,pnts);
    % [OrdfillInt,spnts2] = myRemoveDuplics(OrdfillInt);
    OrdfillInt = FPathS;

    % -------------------------------------------------------------------------
    % COMMENTED - To REMOVE SPLINE - Replaced by LAPLACIAN APPROACH------------
    % -------------------------------------------------------------------------




    %SAMPLING POINTS ON SPLINE FIT - DONE
    %==========================================================================
    %==========================================================================
    %CORRECTING THE END POINTS AND SAMPLING - START
    padFac = smpWidth + 10;
    [Ordfill, xv, yv, xvp, yvp] = Col7(I,SamP,OrdfillInt,x1,y1,x2,y2,ptel1,ptel2,201,figflag);

    % Rounding off to correspond with actual pixel points
    xv  = round(xv); 
    yv  = round(yv); 
    xvp = round(xvp); 
    yvp = round(yvp);


    %pause
    [Wprofile1, Iprofile1, RecMidPnt, flagDiv,lineMain,lineOther,line1,line2] = laplacianapply(I, BW2, Ordfill, xv, yv, xvp, yvp, bands, ptel1, ptel2, factor,figflag);

    if (flagDiv==1)
        disp('Dont execute anything now  Division error!')
        %pause
        %return;
    end

    %save (Filetempnumb,'Wprofile1','Wprofile2','Iprofile1','Iprofile2')



    % CHANGES FOR ACCOMODATING LAPLACIAN
    % APPROACH---------------------------------------------------------------
    % -------------------------------------------------------------------------
    % -------------------------------------------------------------------------
    % -------------------------------------------------------------------------
    % -------------------------------------------------------------------------
    % -------------------------------------------------------------------------
    % -------------------------------------------------------------------------
    % ONE BIG UNCOMMENT WOULD GET YOU BACK ON TRACK,,,,,,,,,,,,,,,,,,,,,,,,,,,,


    % disp('----------------')
    % disp('Final Results')
    % 
    % if(~isempty(spnts3))
    %     Totpnts = spnts2+spnts3;
    % else
    %     Totpnts = spnts2;
    % end
    % 
    % 
    % 
    % 
    % 
    % 
    % %CORRECTING THE END POINTS AND SAMPLING - DONE
    % %==========================================================================
    % %==========================================================================
    % %GETTING EUCLEDIAN LENGTHS - START
    % 
    % disp('----------------')
    % disp('The Eucledian Length')
    % 
    % [EUL] = myEuclLength(Ordfill,ImgScale)
    % 
    % disp('----------------')
    % 
    % %GETTING EUCLEDIAN LENGTHS - DONE
    % %==========================================================================
    % %==========================================================================
    % %FINDING THE CONTROMERE - START
    % 
    % save (BOUNDname,'BW2','I')
    % 
    % [Cent,AvgInt] = myCentroFind(I,BW2,OrdfillInt);
    % 
    % BackupC = OrdfillInt;
    % 
    % 

    Cent   = Wprofile1;
    AvgInt = Iprofile1;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    maxR = max(AvgInt(:));
    maxSm = max(Cent(:));
    minR = 0;

    scCent = Cent.*(maxR/maxSm);   

        if (ImgType==0)
            FCentR = scCent+AvgInt;
            disp('DAPI DAPI DAPI!!!')
            %pause
        else
            FCentR = scCent;
            disp('GEIMSA GEIMSA GEIMSA!!!')
            %pause
        end


    minCent = min(FCentR(:));       %minimum RESULT value 

    szCent = size(FCentR,1)

    minInd = find(FCentR==minCent); %indices of the minimum value
    minindS = size(minInd,1);       %number of minimum occurances


    % figure
    % plot(FCentR,'r')
    % hold on
    % plot(minInd,1,'*b')
    % grid on
    % grid minor
    % hold off
    % title('ORIGINAL PROFILE')

    if(minindS>1)
        Cmidind = minInd(floor(minindS/2))
    else
        Cmidind = minInd
    end

    %Checking for minimum values at end points
    redamnt = 0 % The amount to blank out in this case
    shifting1 = 0 % Variable used to decide the shifting of the final centromere location.
    if(Cmidind<=2)
        disp('Minimum Point is the left corner')

        redamnt = floor(szCent/5)
        shifting1 = floor(szCent/5)
        FCentR(1:redamnt,:) = [];
        disp('DOING IT AGAIN NOW - Looking for a better minima')
        minCent = min(FCentR(:));       %minimum RESULT value 
        minInd = find(FCentR==minCent); %indices of the minimum value
        minindS = size(minInd,1);       %number of minimum occurances

        if(minindS>1)
            Cmidind = minInd(floor(minindS/2))
        else
            Cmidind = minInd
        end

    %     figure
    %     plot(FCentR,'r')
    %     hold on
    %     plot(minInd,1,'*b')
    %     grid on
    %     grid minor
    %     hold off
    %     title('CHANGED PROFILE')
    end

    if(Cmidind>=szCent-1)
        disp('Minimum Point is the right corner')

        redamnt = floor(szCent/5)
        shifting1 = 0
        FCentR(szCent-redamnt:end,:) = [];
        disp('DOING IT AGAIN NOW - Looking for a better minima')
        minCent = min(FCentR(:));       %minimum RESULT value 
        minInd = find(FCentR==minCent); %indices of the minimum value
        minindS = size(minInd,1);       %number of minimum occurances

        if(minindS>1)
            Cmidind = minInd(floor(minindS/2))
        else
            Cmidind = minInd
        end

    %     figure
    %     plot(FCentR,'r')
    %     hold on
    %     plot(minInd,1,'*b')
    %     grid on
    %     grid minor
    %     hold off
    %     title('CHANGED PROFILE')
    end



    %pause

    centX = RecMidPnt(shifting1+Cmidind,1);     
    centY = RecMidPnt(shifting1+Cmidind,2); 
    cind = shifting1+Cmidind;
end
%============================================================ 

%%COMMENTED OUT FOR NATASHA's VERSION
%
% figure                    %The Centromere Location Plot
% imshow(I,[])
% hold on
% plot(centX,centY,'y*','LineWidth',4)
% hold off
% title(['Centromere Location-Laplacian Method' factorVble])
% saveas(gcf,finalimage)

%============================================================ 

%Cminind - the median of the minimum value occurance

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% %0000000000000000000000000000000000000000000
% % figure
% % plot(Cent(:))
% % title('Width Profile')
% % saveas(gcf,'WidthProfile.tif')
% % 
% % figure
% % plot(AvgInt(:))
% % title('Intensity Profile')
% % saveas(gcf,'IntensityProfile.tif')
% %0000000000000000000000000000000000000000000
% 
% maxR = max(AvgInt(:));
% maxSm = max(Cent(:));
% minR = 0;
% 
% % vr =size(Cent,1);
% % diff =maxR-minR
% % diff(diff ==0) =1;% Avoid dividing by zero
% % scCent =(Cent-repmat(minR, vr,1))./(repmat(diff,vr,1))*maxR;
% 
% scCent = Cent.*(maxR/maxSm);   
% 
%     if (ImgType==0)
%         FCentR = scCent+AvgInt;
%         %disp('DAPI DAPI DAPI!!!')
%         %pause
%     else
%         FCentR = scCent;
%         %disp('GEIMSA GEIMSA GEIMSA!!!')
%         %pause
%     end
% 
% 
% % figure
% % plot(scCent(:))
% % title('SCALED UP!')
% % 
% 
% %0000000000000000000000000000000000000000000
% % figure
% % plot(FCentR(:))
% % title('Result Profile')
% % saveas(gcf,'ResultProfile.tif')
% %0000000000000000000000000000000000000000000
% 
% minCent = min(FCentR(:));       %minimum RESULT value 
% minInd = find(FCentR==minCent); %indices of the minimum value
% minindS = size(minInd,1);       %number of minimum occurances
% 
% if(minindS>1)
%     Cmidind = minInd(floor(minindS/2));
% else
%     Cmidind = minInd;
% end
% 
% %Cminind - the median of the minimum value occurance
% 
% OrdfX = OrdfillInt(:,1);
% OrdfY = OrdfillInt(:,2);
% 
% midLen = size(OrdfX,1);         %Length of the segment used for CI calc.
% 
% centX = OrdfX(Cmidind);     %X coordinate of the median minm val
% centY = OrdfY(Cmidind);     %Y coordinate of the median minm val
% 
% %++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% %++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% %% Second Centromere Finding
% FCentR2 = FCentR;
% OrdfillInt2 = OrdfillInt;
% 
% leftRed  = 22;
% rightRed = 22;
% %Cmidind;
% midLen2 = size(FCentR,1);
% 
% if ((Cmidind - leftRed)<1)
%     leftRed = Cmidind - 1;
% end
% 
% if ((Cmidind + rightRed)>midLen2)
%     rightRed = midLen2 - Cmidind;
% end
% 
% leftInd  = Cmidind - leftRed;
% rightInd = Cmidind + rightRed;
% 
% %whos FCentR2
% 
% FCentR2(leftInd:rightInd, :)=[];
% OrdfillInt2(leftInd:rightInd, :)=[];
% 
% minCent2 = min(FCentR2(:));       %minimum RESULT value 
% minInd2 = find(FCentR2==minCent2); %indices of the minimum value
% minindS2 = size(minInd2,1);       %number of minimum occurances
% 
% if(minindS2>1)
%     Cmidind2 = minInd2(floor(minindS2/2));
% else
%     Cmidind2 = minInd2;
% end
% 
% OrdfX2 = OrdfillInt2(:,1);
% OrdfY2 = OrdfillInt2(:,2);
% 
% midLen3 = size(OrdfX2,1);         %Length of the segment used for CI calc.
% 
% centX2 = OrdfX2(Cmidind2);     %X coordinate of the median minm val
% centY2 = OrdfY2(Cmidind2);     %Y coordinate of the median minm val
% 
% 
% %0000000000000000000000000000000000000000000
% % figure
% % plot(FCentR2(:))
% % title('Deleted Profile')
% % saveas(gcf,'DeletedProfile.tif')
% %0000000000000000000000000000000000000000000
% 
% % pause
% 
% 
% 
% %++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% %++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% %% 
% % figure                    %The Centromere Location Plot
% % imshow(I,[])
% % hold on
% % plot(centX,centY,'w*','LineWidth',4)
% % hold off
% 
% 
% % C = xcov(scCent,AvgInt,'unbiased');
% % whos scCent
% % whos C
% % minCent2 = min(C(:));
% % minInd2 = find(C==minCent2)
% % centX2 = OrdfX(round(minInd2/2));
% % centY2 = OrdfY(round(minInd2/2));
% % figure
% % imshow(I,[])
% % hold on
% % plot(centX2,centY2,'y*','LineWidth',5)
% % hold off
% 
% %FINDING THE CONTROMERE - DONE
% %==========================================================================
% %==========================================================================
% %% FINDING THE FRACTIONAL RATIO - START
% [Find,Fpair] = myPointProject(Ordfill,halfsizeC,halfsizeR,I); %Project the pnt
% 
% polarity = 0; %This Sets the Polarity of the Medial Axis....
% % if = '1' -> The Set1 is the Long arm Q (ARM)
% % if = '2' -> The Set1 is the Short arm P (ARM)
% 
% upperS1 = szseg1 + Cmidind - 1;
% lowerS2 = upperS1 + 1;
% 
% Set1 = Ordfill(1:upperS1,:);
% Set2 = Ordfill(lowerS2:end,:);
% 
% %COMMENT LATER--------
% % szseg1
% % szseg2
% % szSet1 = size(Set1,1)
% % szSet2 = size(Set2,1)
% %COMMENT LATER--------
% 
% Set1L = myEuclLength(Set1,ImgScale)+1;
% Set2L = myEuclLength(Set2,ImgScale);
% 
% if (Set1L >= Set2L)
%     polarity = 1;
% else
%     polarity = 2;
% end
% 
% Set1PP = Ordfill(1:Find,:);
% Set2PP = Ordfill(Find:end,:);
% 
% %COMMENT LATER--------
% % szSetPP1 = size(Set1PP,1)
% % szSetPP2 = size(Set2PP,1)
% %COMMENT LATER--------
% 
% Set1PPL = myEuclLength(Set1PP,ImgScale);
% Set2PPL = myEuclLength(Set2PP,ImgScale);
% 
% %RATIO CALCULATIONS - 
% %Centromere Index (Short Arm (P)/Total Length)
% if (polarity == 1)
%     CI = Set2L / EUL;
% else
%     CI = Set1L / EUL;
% end
% 
% 
% %We are going for 3 Measurements----
% %Measure1 (M1) = (Ptelo <-> P) / (Qtelo <-> P)
% %Measure1 (M2) = (P <-> Centro) / (P <-> Qtelo)
% %Measure1 (M3) = (P <-> Centro) / (P <-> Ptelo)
% %4 scenarios.....scenario....
% 
% if (polarity == 1)
%     %C
%     if (Set1PPL <= Set1L)
%         scenario = 1;
%         M1 = Set2PPL / Set1PPL;
%         M2 = (Set1L-Set1PPL) / Set1PPL;
%         M3 = (Set1L-Set1PPL) / Set2PPL;
%     else
%         scenario = 2;
%         M1 = Set2PPL / Set1PPL;
%         M2 = (Set2L-Set2PPL) / Set1PPL;
%         M3 = (Set2L-Set2PPL) / Set2PPL;
%     end
% else      
%     %D
%     if(Set1PPL <= Set1L)
%         scenario = 3;
%         M1 = Set1PPL / Set2PPL;
%         M2 = (Set1L-Set1PPL) / Set2PPL;
%         M3 = (Set1L-Set1PPL) / Set1PPL;
%     else
%         scenario = 4;
%         M1 = Set1PPL / Set2PPL;
%         M2 = (Set2L-Set2PPL) / Set2PPL;
%         M3 = (Set2L-Set2PPL) / Set1PPL;
%     end
% end
% 
% 
% %FINDING THE FRACTIONAL RATIO - DONE
% %==========================================================================
% %==========================================================================
% %ALWAYS STORED IN Q ---  P ORDER (LONG -> SHORT ARMS)
% loopto = size(Ordfill,1);
% looptoprun = size(OrdfillInt,1);
% %Ordfill
% WrtCenter = [];
% WrtCenterPrun = [];
% 
% if (polarity == 1)
%     WrtCenter = Ordfill;
%     WrtCenterPrun = OrdfillInt;
% else
%     WrtCenter = flipdim(Ordfill,1);
%     WrtCenterPrun = flipdim(OrdfillInt,1);
% end
% 
% for t=1:loopto
% fprintf(fidcenter,'%4.2f \t %4.2f \r\n',WrtCenter(t,1),WrtCenter(t,2));
% end
% fclose(fidcenter);
% 
% for u=1:looptoprun
% fprintf(fidcenterprun,'%4.2f \t %4.2f \r\n',WrtCenterPrun(u,1),WrtCenterPrun(u,2));
% end
% fclose(fidcenterprun);
% 
% [TCord] = thincord(BWthin);
% loopbench = size(TCord,1);
% 
% for v=1:loopbench
% fprintf(fidbench,'%4.2f \t %4.2f \r\n',TCord(v,1),TCord(v,2));
% end
% 
% fclose(fidbench);
% %Lengths File is written in this Order...
% % Figure Name
% % X and Y coordinates
% % EUL
% % CI
% % M1
% % M2
% % M3
% fprintf(fidlengths,'%20s\r\n',imagename);
% fprintf(fidlengths,'%4f\r\n',intskllng);
% fprintf(fidlengths,'%4.4f \t %4.4f \r\n',corC,corR);
% fprintf(fidlengths,'%4.4f\r\n',EUL);
% fprintf(fidlengths,'%4.4f\r\n',CI);
% fprintf(fidlengths,'%4.4f\r\n',M1);
% fprintf(fidlengths,'%4.4f\r\n',M2);
% fprintf(fidlengths,'%4.4f\r\n',M3);
% fclose(fidlengths);

% fprintf(fidcentroPos,'%4.4f \t %4.4f \r\n',centX,centY);
% %fprintf(fidcentroPos,'%4.4f \t %4.4f \r\n',centX2,centY2);
% fclose(fidcentroPos);

% widmin = min(Cent(:));
% widProfmin = min(scCent(:));   %Min of the Scaled width profile
% selectoptim = FCentR(Cmidind);  %Selected optimum 
% ECentroV = Cent(Cmidind);       %Selected Centromere 
% widprofgap = size(find(Cent==widmin),1);
% 
% if (widprofgap>1)
%     CENTROCONFID = ((widProfmin + min(AvgInt(:)))/(selectoptim*0.51*widprofgap)) * 100
% else
%     CENTROCONFID = ((widProfmin + min(AvgInt(:)))/(selectoptim)) * 100
% end
% 
% 
% NCentX = centX;
% NCentY = centY;
% 
% fprintf(fidCENTRO,'%4.2f\r\n',thrFac);
% % fprintf(fidCENTRO,'%4.2f\r\n',widProfmin);
% % fprintf(fidCENTRO,'%4.2f\r\n',min(AvgInt(:)));
% % fprintf(fidCENTRO,'%4.2f\r\n',selectoptim);
% % fprintf(fidCENTRO,'%4.2f\r\n',widprofgap);
% % fprintf(fidCENTRO,'%4.2f\r\n',CENTROCONFID);
% % fclose(fidCENTRO);
% fclose(fidCENTRO);
% 
% % disp('Check the File')
% % pause
% 
% %if (CENTROCONFID<90)
% [NCentX, NCentY] = CENTROREFINETFunc1(I,BW2,COMB,imagename,number,1);
% %end
% 
% 
% %[NCentX2 NCentY2] = CENTROREFINETFunc1(I,BW2,imagename,number,2);
% 
% 
% 
% 
% % figure
% % imshow(I,[])
% % hold on
% % %plot(Ordfill(:,1),Ordfill(:,2),'y','LineWidth',2)
% % %hold on
% % % plot(halfsizeC,halfsizeR,'r*','LineWidth',2)
% % % hold on
% % % plot(Fpair(1),Fpair(2),'b*','LineWidth',2)
% % % hold on
% % plot(centX,centY,'y*','LineWidth',3)
% % %hold on
% % %plot(centX2,centY2,'b*','LineWidth',3)
% % hold off
% % %saveas(gcf,strcat(imagename,numb1),'tif')
% % saveas(gcf,finalimage,'tif')
% 
% ERROR = '_ERROR_';
% errorname = [imagename ERROR numb1 Formatt];
% fiderror = fopen(errorname,'w');
% 
% centX
% centY
% NCentX
% NCentY
% 
% ErrorV = sqrt((NCentX-centX)^2 + (NCentY-centY)^2)
% fprintf(fiderror,'%4.2f\r\n',ErrorV);
% fclose(fiderror);










