function [ptel1,ptel2,pside1,pside2,cont,PosSets,DemoFlag,StateFeatureMat] = autosegmentNEW2(aaA,bbA,xxA,yyA,I,tx1A,ty1A,figflag,x1A,y1A,number,foldrName)

% Program created for automatically segmenting the contour partitions based
% on the DCE points (6 points) - This attempts to select the 4 telomere
% points of the chromosome.
% aaA,bbA - Points on the contour aaA - row number, bbA - column number
% xxA,yyA - DCE 6 points on the contour. xxA - row number,
% tx1A,ty1A - The 2 points on the telomeres.  tx1A - row number,
% x1A,y1A - Points where the skeleton touches the contour (Can be less than
% the number of points in the xxA and yyA.
% DemoFlag is used only to collect data for contour partitioning- Setting it to one will by pass
% all other processing.
DemoFlag = 1
clc

% figure
% imshow(I,[])
% hold on
% plot(bbA,aaA,'r*')
% hold on
% plot(yyA,xxA,'bs')
% hold on
% plot(ty1A,tx1A,'y*')
% hold off
% pause

Tel1Flag = 0; 
Tel2Flag = 0;
%Flag value key - 
% 0 - Both points are within the contour (no need to worry about looping)
% 1 - Main point - 1, the closest is - 6.
% 2 - Main point - 6, the closest is - 1.

Tel1Dir = 1;
Tel2Dir = 1;

Fpnts = zeros(4,2);
Fpnts(1,:) = [tx1A(1) ty1A(1)];
Fpnts(3,:) = [tx1A(2) ty1A(2)];

doneflag = 0;


aaA = aaA';
bbA = bbA';
cont = [aaA bbA];

len = size(cont,1);

xxA(end) = [];
yyA(end) = [];
Points = [xxA yyA];
PointsSkelEnds = [x1A y1A];

%pause 

n = size(Points,1);

indlist = [];

for i=1:6

    T = [xxA(i) yyA(i)];
    T = repmat(T,len,1);
    ind = (cont==T);
    ind = sum(ind,2);
    indv = find(ind==2);
    indlist = [indlist; indv];
    
end

% T = circshift(indlist,-1);
% fdist = T-indlist;
% tval = (len - indlist(end)) + T(end);
% 
% fdist(end) = tval
% 
% bdist = circshift(fdist,1)
% 
% distset = [fdist bdist]
% 
% distThr = len/7
% 
% disind = find(sum(distset>distThr,2)==2)
% 
% if (~isempty(disind))
%     A = 9;
%     
%     szlrg = size(disind,1)
%     
%     if(szlrg < 3)
%         disp('One or Two Points')
%         Points(disind,:) = [];
%         distset(disind,:) = [];
%         indlist(disind,:) = [];
%         n = n - szlrg;
%             if (szlrg == 2)
%                 doneflag = 1
%             end
%         
%     else
%         disp('More Than Two Points')
%         Points(disind(1:2),:) = [];
%         distset(disind(1:2),:) = [];
%         indlist(disind(1:2),:) = [];
%         n = n - 2;
%         doneflag = 1
%     end
%     
% else
%     disp('Nothing Reduced...all 6 remains')
% end

Points
PointsSkelEnds
n
indlist
len

endpnts = [tx1A ty1A]; 
%Finding the Placement (indices within the points)
    T   = [tx1A(1) ty1A(1)];
    T = repmat(T,n,1);
    tP1 = (Points==T);
    tP1 = sum(tP1,2);
    indvP1 = find(tP1==2)
    P1pos = indlist(indvP1);
    
    T   = [tx1A(2) ty1A(2)];
    T = repmat(T,n,1);
    tP2 = (Points==T);
    tP2 = sum(tP2,2);
    indvP2 = find(tP2==2);
    P2pos = indlist(indvP2);
    
%&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
% Finding out the difference betw PointsSkelEnds and Points

skelFeat = ones(size(Points,1),1)

if(size(Points,1)==size(PointsSkelEnds,1))
    disp('No difference between the two sets-all points have skel ends');
else
    disp('Two sets are different');
    for i=1:size(Points,1)
        i
        S = [Points(i,1) Points(i,2)];
        S = repmat(S,size(PointsSkelEnds,1),1);
        sP1 = (PointsSkelEnds==S);
        sP1 = sum(sP1,2);
        sindP1 = find(sP1==2);    
        if(isempty(sindP1))
            disp('Found the bugger');
            skelFeat(i) = 0;
        end
       % pause
    end
    disp('Loop Ends');
end
skelFeat   

%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
P1pos
P2pos

indvP1
indvP2

pointSetLabels = [1;2;3;4;5;6]
P1Lable = pointSetLabels(indvP1)
P2Lable = pointSetLabels(indvP2)
subSetPnts = indlist
removeind = [indvP1;indvP2]
subSetPnts(removeind) = []
skelFeat(removeind) = []
pointSetLabels(removeind) = []

%disp('ABOVE, the Ends were removed!!!');
%pause

mainSates = (n-2)
subSet = 1:(n-2)
[AngleSet] = myCurvefindingNEW(aaA,bbA,I);
SelectAng1 = myCumCurvValue(AngleSet,P1pos,len)
SelectAng2 = myCumCurvValue(AngleSet,P2pos,len)

CurvValSet = [SelectAng1;SelectAng2]
for u=1:size(subSetPnts,1)
    u
    CurvValSet = [CurvValSet;myCumCurvValue(AngleSet,subSetPnts(u),len)];
end



%pause

StateFeatureMat = [];
CurvValSet
maxPos = max(CurvValSet(:))
minPos = min(CurvValSet(:))

PosInd = CurvValSet>0
ind2 = PosInd;
ind2 = ind2./maxPos;

NegInd = CurvValSet<0
negI = find(CurvValSet<0)
if(isempty(negI))
    disp('No negative values');
else
    indT = NegInd./abs(minPos)
    ind2 = ind2 + indT
end

ind3 = ind2==0;
PosInd = ind2+ind3
CurvValSetN = CurvValSet.*PosInd

disp('Scaling of angles DONE!')
SelectAng1 = CurvValSetN(1);
CurvValSetN(1) = []
SelectAng2 = CurvValSetN(1);
CurvValSetN(1) = []

%whos CurvValSetN

%pause

LengthFeatureMat = [];

% The Key to StateFeatureMat - 
% 
% [Chrnumber->Indices of points->Angle values at pnts->EndPs have Skel]
%              EP1 cPi EP2 cPj -> EP1 cPi EP2 cPj    -> cPi cPj 

%AngleSet = [];
for i = 1:mainSates
    for j = 1:(n-2)
        if(i==j)
            disp('i and j match.')
        else
            [i,j]
            %StateFeatureMat = [StateFeatureMat;P1pos subSetPnts(i) P2pos subSetPnts(j) SelectAng1 myCumCurvValue(AngleSet,subSetPnts(i),len) SelectAng2 myCumCurvValue(AngleSet,subSetPnts(j),len) skelFeat(i) skelFeat(j) myEuclLengthNEW(P1pos,subSetPnts(i),cont) myEuclLengthNEW(P2pos,subSetPnts(j),cont)  myEuclLengthNEW(P1pos,subSetPnts(j),cont) myEuclLengthNEW(P2pos,subSetPnts(i),cont)];
            StateFeatureMat = [StateFeatureMat;number P1Lable pointSetLabels(i) P2Lable pointSetLabels(j) P1pos subSetPnts(i) P2pos subSetPnts(j) SelectAng1 CurvValSetN(i) SelectAng2 CurvValSetN(j) skelFeat(i) skelFeat(j)];
            LengthFeatureMat = [LengthFeatureMat;myEuclLengthNEW(P1pos,subSetPnts(i),cont) myEuclLengthNEW(P2pos,subSetPnts(j),cont)  myEuclLengthNEW(P1pos,subSetPnts(j),cont) myEuclLengthNEW(P2pos,subSetPnts(i),cont)];
            %AngleSet = [AngleSet; SelectAng1 myCumCurvValue(AngleSet,subSetPnts(i),len) SelectAng2 myCumCurvValue(AngleSet,subSetPnts(j),len)]
            %pause
        end
    end
end


LengthRatio = [LengthFeatureMat(:,1)./LengthFeatureMat(:,3) LengthFeatureMat(:,2)./LengthFeatureMat(:,4)]

MaxLengthRatio = max(LengthRatio)

DiffR = [];

for i=1:size(StateFeatureMat,1)
   if(LengthRatio(i,1)<= LengthRatio(i,2))
      %ratio1 = B(i,1)/B(i,2);
       ratio1 = 1-(LengthRatio(i,2)-LengthRatio(i,1))/LengthRatio(i,2);
   else
      %ratio1 = B(i,2)/B(i,1);
       ratio1 = 1- (LengthRatio(i,1)-LengthRatio(i,2))/LengthRatio(i,1);
   end

   DiffR = [DiffR;ratio1];
end

StateFeatureMat
len

LengthFeatureMat

DiffR 

TelR1 = 1 - LengthRatio(:,1)./MaxLengthRatio(1)
TelR2 = 1 - LengthRatio(:,2)./MaxLengthRatio(2)

StateFeatureMat = [StateFeatureMat DiffR TelR1 TelR2]

%AngleSet = StateFeatureMat(:,10:13);
%AngleSet


ForFun = sum(StateFeatureMat(:,10:18),2)

disp('Ready to Record (in Excel!');
pause
%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% FILE I/O PART

num = xlsread('Book1.xls')

%xlswrite('Book1.xls', A,'Sheet1', 'A2')

char1 = 'A'

if(size(num,1)==0)
	char2 = [char1 num2str(size(num,1)+2)]
else
	char2 = [char1 num2str(size(num,1)+3)]
end

xlswrite('Book1.xls', StateFeatureMat,'Sheet1', char2)

exten = '.mat';
Tpref2 = 'DCEPoints';
TempFile2 = [foldrName Tpref2 int2str(number) exten]
save(TempFile2,'Points','PointsSkelEnds','n','indlist','len','cont','P1pos','P2pos','indvP1','indvP2','subSetPnts','CurvValSet','CurvValSetN','StateFeatureMat');

%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



% SelectAngV1 = myCumCurvValue(AngleSet,subSetPnts(1),len)
% SelectAngV2 = myCumCurvValue(AngleSet,subSetPnts(2),len)
% SelectAngV3 = myCumCurvValue(AngleSet,subSetPnts(3),len)
% SelectAngV4 = myCumCurvValue(AngleSet,subSetPnts(4),len)
disp('DONT HIT ENTER!!!');
%pause
ptel1 =1;
ptel2 =1;
pside1 =1;
pside2 =1;
PosSets =1;

% distP1 = zeros(2,1);
% distP2 = zeros(2,1);
% %Finding the Closest to the 1st Guy
% %Forward distance
% if (indvP1==1)
%     disp('The first point is at the top.Forward - OK, Backward - prob')
%     distP1(1) = indlist(indvP1+1) - indlist(indvP1);            %Forward
%     distP1(2) = (len - indlist(6)) + (indlist(indvP1)-1);       %Backward
%     
%     if(distP1(1) <= distP1(2));
%         sP1 = cont(indlist(indvP1+1),:);                        %Forward
%         sP1pos = indlist(indvP1+1);
%         sP1posPnts = 2;    
%         Tel1Dir = 1;             %Means Forward    
%     else
%         sP1 = cont(indlist(6),:);
%         sP1pos = indlist(6);
%         sP1posPnts = 6;
%         Tel1Flag = 1;
%         Tel1Dir = 2;            %Means Backward
%     end
%     
% elseif(indvP1==6)
%     disp('The first point is at the bottom.Forward - prob, Backward - OK')
%     distP1(1) = (len - indlist(indvP1)) + (indlist(1)-1);       %Forward
%     distP1(2) = indlist(indvP1) - indlist(indvP1-1);
%     
%     if(distP1(1) <= distP1(2))
%         sP1 = cont(indlist(1),:);                                %Forward
%         sP1pos = indlist(1);
%         sP1posPnts = 1;
%         Tel1Flag = 2;
%         Tel1Dir = 1;
%     else
%         sP1 = cont(indlist(indvP1-1),:);
%         sP1pos = indlist(indvP1-1);
%         sP1posPnts = 5;
%         Tel1Dir = 2;
%     end
% else
%     disp('The first point is in the middle.Forward - OK, Backward - OK')
%     distP1(1) = indlist(indvP1+1) - indlist(indvP1);            %Forward
%     distP1(2) = indlist(indvP1) - indlist(indvP1-1);
%     
%     if(distP1(1) <= distP1(2))
%         sP1 = cont(indlist(indvP1+1),:);                         %Forward
%         sP1pos = indlist(indvP1+1);
%         sP1posPnts = indvP1+1;
%         Tel1Dir = 1;
%     else
%         sP1 = cont(indlist(indvP1-1),:);
%         sP1pos = indlist(indvP1-1);
%         sP1posPnts = indvP1-1;
%         Tel1Dir = 2;
%     end
%     
% end
% 
% 
% %Finding the Closest to the 2nd Guy
% %Forward distance
% if (indvP2==1)
%     disp('The second point is at the top.Forward - OK, Backward - prob')
%     distP2(1) = indlist(indvP2+1) - indlist(indvP2);        %Forward
%     distP2(2) = (len - indlist(6)) + (indlist(indvP2)-1);   %Backward
%     
%     if(distP2(1) <= distP2(2))                              
%         sP2 = cont(indlist(indvP2+1),:);                     %Forward
%         sP2pos = indlist(indvP2+1);
%         sP2posPnts = 2;
%         Tel2Dir = 1;
%     else
%         sP2 = cont(indlist(6),:);
%         sP2pos = indlist(6);
%         sP2posPnts = 6;
%         Tel2Flag = 1;
%         Tel2Dir = 2;
%     end
%     
% elseif(indvP2==6)
%     disp('The second point is at the bottom.Forward - prob, Backward - OK')
%     distP2(1) = (len - indlist(indvP2)) + (indlist(1)-1);   %Forward
%     distP2(2) = indlist(indvP2) - indlist(indvP2-1);
%     
%     if(distP2(1) <= distP2(2))
%         sP2 = cont(indlist(1),:);                            %Forward
%         sP2pos = indlist(1);
%         sP2posPnts = 1;
%         Tel2Flag = 2;
%         Tel2Dir = 1; 
%     else
%         sP2 = cont(indlist(indvP2-1),:);
%         sP2pos = indlist(indvP2-1);
%         sP2posPnts = 5;
%         Tel2Dir = 2;
%     end
%     
% else
%     disp('The second point is in the middle.Forward - OK, Backward - OK')
%     distP2(1) = indlist(indvP2+1) - indlist(indvP2);        %Forward
%     distP2(2) = indlist(indvP2) - indlist(indvP2-1);
%     
%     if(distP2(1) <= distP2(2))
%         sP2 = cont(indlist(indvP2+1),:);                     %Forward
%         sP2pos = indlist(indvP2+1);
%         sP2posPnts = indvP2+1;
%         Tel2Dir = 1;
%     else
%         sP2 = cont(indlist(indvP2-1),:);
%         sP2pos = indlist(indvP2-1);
%         sP2posPnts = indvP2-1;
%         Tel2Dir = 2;
%     end
%     
% end
% 
% 
% % figure
% % imshow(I,[])
% % hold on
% % plot(Points(:,2),Points(:,1),'sb','linewidth',5)
% % hold on
% % plot(bbA,aaA,'r')
% % hold on
% % plot(ty1A,tx1A,'*w')
% % hold on
% % plot(sP1(2),sP1(1),'*y')
% % hold on
% % plot(sP2(2),sP2(1),'*y')
% % % hold on
% % % plot(Z(:,2),Z(:,1),'y')
% % hold off
% % title('Current Result-1')
% 
% PosSets = [P1pos;sP1pos;P2pos;sP2pos];
% PosSetsInd = zeros(4,1);
% 
% %pause
% 
% contbk = ones(len,1);
% 
% %indvP1 (4) , P1pos (88)
% %sP1posPnts (5), sP1pos (104) 
% %RECTIFYING DESREPENCES....
% %Finding the Telomere 1 points
% disp('TELOMERE 1') 
% if (Tel1Flag==0)
%     disp('NO BACK-FORWARD PROBLEMS')   
%     if(Tel1Dir==1)
%         ptel1 = cont(P1pos:sP1pos,:);                         %Forward 
%         contbk(P1pos:sP1pos) = 0;
%     else
%         ptel1 = cont(sP1pos:P1pos,:);
%         contbk(sP1pos:P1pos) = 0;
%     end
%     
% elseif(Tel1Flag==1)
%     disp('MAIN POINT is -ONE- and the next point is -SIX- Go from 6 towards 1 forward')
%     ptel1 = [cont(sP1pos:len,:);cont(1:P1pos,:)]; 
%     contbk(sP1pos:len) = 0;
%     contbk(1:P1pos) = 0;
%     
% else
%     disp('MAIN POINT is -SIX- and the next point is -ONE- Go from 6 towards 1 forward')
%     ptel1 = [cont(P1pos:len,:);cont(1:sP1pos,:)];  
%     contbk(P1pos:len) = 0;
%     contbk(1:sP1pos) = 0;
% end
% 
% %indvP2 (4) , P2pos (88)
% %sP2posPnts (5), sP2pos (104)
% %Finding the Telomere 2 points
% disp('TELOMERE 2') 
% if (Tel2Flag==0)
%     disp('NO BACK-FORWARD PROBLEMS')   
%     if(Tel2Dir==1)
%         ptel2 = cont(P2pos:sP2pos,:);                         %Forward 
%         contbk(P2pos:sP2pos) = 0;
%     else
%         ptel2 = cont(sP2pos:P2pos,:);
%         contbk(sP2pos:P2pos) = 0;
%     end
%     
% elseif(Tel2Flag==1)
%     disp('MAIN POINT is -ONE- and the next point is -SIX- Go from 6 towards 1 forward')
%     ptel2 = [cont(sP2pos:len,:);cont(1:P2pos,:)]; 
%     contbk(sP2pos:len) = 0;
%     contbk(1:P2pos) = 0;
%     
% else
%     disp('MAIN POINT is -SIX- and the next point is -ONE- Go from 6 towards 1 forward')
%     ptel2 = [cont(P2pos:len,:);cont(1:sP2pos,:)];  
%     contbk(P2pos:len) = 0;
%     contbk(1:sP2pos) = 0;
% end
% 
% 
% 
% disp('SIDE 1')
% disp('SIDE 2')
% 
% [L, num] = bwlabel(contbk, 4);
% num
% 
% if (num<3)
%     sideind1 = find(L==1);
%     pside1 = cont(sideind1,:);
%     sideind2 = find(L==2);
%     pside2 = cont(sideind2,:);
% else
%     sideind1A = find(L==1);
%     sideind1B = find(L==3);
%     pside1 = [cont(sideind1A,:);cont(sideind1B,:)];
%     sideind2 = find(L==2);
%     pside2 = cont(sideind2,:);    
% end
% 
% 
% 
% 
% 
% % if (~doneflag)
%     
%     
%     
% %     Xset = []; %DELETE THIS LATER
% %     Yset = []; %DELETE THIS LATER
% %     
% %     DX = [];
% %     DY = [];
% %     gap = 4;
% %     
% %     n
% %     len
% %     for k=1:n
% %         %k
% %         %INDVOKK = indlist(k)
% %         bkind = indlist(k) - gap
% % 
% %         if(bkind < 1)
% %             disp('Special-BACK')
% %             rest = indlist(k) - 1
% %             bkind = len - (gap - rest)
% %         end
% % 
% %         fwind = indlist(k) + gap
% % 
% %         if(fwind > len)
% %             disp('Special-FORWARD')
% %             rest = len - indlist(k)
% %             fwind = 1 + (gap - rest)
% %         end
% % 
% %         Xset = [Xset; aaA(bkind) aaA(indlist(k)) aaA(fwind)]; %DELETE THIS LATER
% %         Yset = [Yset; bbA(bkind) bbA(indlist(k)) bbA(fwind)]; %DELETE THIS LATER
% %         
% %         DX = [DX; (aaA(bkind)-aaA(indlist(k)))-(aaA(indlist(k))-aaA(fwind))]; 
% %         DY = [DY; (bbA(bkind)-bbA(indlist(k)))-(bbA(indlist(k))-bbA(fwind))];
% %         
% %         
% %     end
% % 
% %     Xset
% %     DX
% %     Yset
% %     DY
% %     
% %     MAG = sqrt(DX.^2 + DY.^2)
% % 
% %     %   Correcting for 90 deg MATH Error.
% %     
% %     corind = (DY==0)
% %     DY(corind) = 0.001
% %     DX
% %     
% %     alpv = atan(DX./DY)*(180/pi)
% %     
% %     %   Now lets remove remaining points based on the curvature.
% %     
% %     n
% %     [mins,IX] = sort(MAG,1)
% %     
% %     if (n==6)
% %         indT = IX(1:2)
% %     else
% %         indT = IX(1)
% %     end
% %     
% %     
% %     Points(indT,:) = [];
% %     distset(indT,:) = [];
% %     indlist(indT,:) = [];
% %     
% %         
% %     
% %     
% %     
% %     
% % %   Correcting for 90 deg MATH Error.
% % %     corind = (DY==0)
% % %     DX
% % %     DY(corind) = 0.001
% % %     
% % %     alpv = atan(DX./DY)*(180/pi)
% % %     
% % %     thetav = alpv(:,1) + alpv(:,2) % This is the Angle value.....
% %     
% % %     %Now lets first remove concave DCE point/points...
% % %     %Looking at the signs of the angles
% % %     posplace = (thetav>=0) %Positive Indices
% % %     pospnts = sum(posplace) %No of + ves
% % %     negplace = (thetav<0)  %Negative Indices
% % %     negpnts = sum(negplace) %No of - ves
% % %     
% % %     if (pospnts>=4)
% % %         disp('Convex points have + ve Theta values')
% % %         Points(negplace,:) = []
% % %         distset(negplace,:) = []
% % %         indlist(negplace,:) = []
% % %         n = n - negpnts
% % %         
% % %     else
% % %         disp('Convex points have - ve Theta values')
% % %         Points(posplace,:) = []
% % %         distset(posplace,:) = []
% % %         indlist(posplace,:) = []
% % %         n = n - pospnts
% % %     end
% %       
%     
% % end
% 
% %For Telomere One
% len
% 
% 
% 
% %ptel1 =1;
% %ptel2 =2;
% %pside1=3;
% %pside2=4;
% % Points
% % PosSets
% 
% if(figflag==1)
%     figure
%     imshow(I,[])
%     hold on
%     %plot(Points(:,2),Points(:,1),'sb','linewidth',5)
%     %plot(cont(PosSets(:),2),cont(PosSets(:),1),'sb','linewidth',5)
%     hold on
%     plot(bbA,aaA,'r')
%     hold on
%     plot(ptel1(:,2),ptel1(:,1),'*y')
%     hold on
%     plot(ptel2(:,2),ptel2(:,1),'*w')
%     hold on
%     plot(pside1(:,2),pside1(:,1),'.r')
%     hold on
%     plot(pside2(:,2),pside2(:,1),'.b')
%     % hold on
%     % plot(Z(:,2),Z(:,1),'y')
%     hold off
%     title('Current Result. Tel1-yellow, Tel2-white, Side1 - red, Side2-blue')
end

%pause

%T2 = [x1A y1A]






