function [coeffListX1, coeffListY1] = callinkfunc(Stroke1, order)

% clear 
% clc

%order = 9;
%Stroke1 = [7515, -7870; 7516, -7877; 7515, -7900; 7517, -7937; 7520, -7964; 7518, -7989; 7520, -8022; 7520, -8054; 7522, -8088; 7522, -8119; 7525, -8144; 7526, -8163; 7532, -8188; 7541, -8196; 7555, -8199; 7589, -8184; 7612, -8177; 7640, -8167; 7668, -8157; 7697, -8137; 7730, -8130; 7753, -8120; 7780, -8118; 7803, -8115; 7819, -8113];

n1 = size(Stroke1,1);

% Separating the X and Y components of the Stroke

Stroke1X = Stroke1(:,1);
Stroke1Y = Stroke1(:,2);


% Getting the distnace from the 1st point

Tstxp = repmat(Stroke1X(1),n1,1);
Tstyp = repmat(Stroke1Y(1),n1,1);
sx1 = Stroke1X - Tstxp;
sy1 = Stroke1Y - Tstyp;


% Getting the Euclidean distance
 
tempsx1 = circshift(sx1,1);
tempsx1(1) = sx1(1);

tempsy1 = circshift(sy1,1);
tempsy1(1) = sy1(1);

distList1 = sqrt((sx1 - tempsx1).^2 + (sy1 - tempsy1).^2);
distList1 = cumsum(distList1);
d1 = distList1;



% Calculating the moment values

momentListX1 = zeros(order+1,1);
for i=0:order
momentListX1(i+1) = momentous(sx1,d1,i,n1);
end

momentListY1 = zeros(order+1,1);
for i=0:order
momentListY1(i+1) = momentous(sy1,d1,i,n1);
end

L = d1(end);

% Calculating Alpha values (Coefficients for X & Y)

coeffListX1 = zeros(order+1,1);
for i=0:order
coeffListX1(i+1) = coeffcalc(L, momentListX1, i);
end


coeffListY1 = zeros(order+1,1);
for i=0:order
coeffListY1(i+1) = coeffcalc(L, momentListY1, i);
end




% Normalizing to [a,b] -> [-1,1]

maxx1 = max(Stroke1X);
maxy1 = max(Stroke1Y);

minx1 = min(Stroke1X);
miny1 = min(Stroke1Y);

a = -1;
b = 1;

coeffListX1(1) = (coeffListX1(1) * (b-a)/(maxx1-minx1) ) + ((a*maxx1 - b*minx1)/(maxx1 - minx1));

for i=2:(order+1)
coeffListX1(i) = (coeffListX1(i) * (b-a)/(maxx1-minx1) );
end



coeffListY1(1) = (coeffListY1(1) * (b-a)/(maxy1-miny1) ) + ((a*maxy1 - b*miny1)/(maxy1 - miny1));

for i=2:(order+1)
coeffListY1(i) = (coeffListY1(i) * (b-a)/(maxy1-miny1) );
end



% Defininig the orthogonal basis functions
syms sx

P0 = 1;

P1 = sx;

P2 = (-1/2) + (3/2)*sx^2;

P3 = (5/2)*sx^3 - (3/2)*sx;

P4 = (3/8) + (35/8)*sx^4 - (15/4)*sx^2;

P5 = (63/8)*sx^5 - (35/4)*sx^3 + (15/8)*sx;

P6 = (-5/16) + (231/16)*sx^6 - (315/16)*sx^4 + (105/16)*sx^2; 

P7 = (429/16)*sx^7 - (693/16)*sx^5 + (315/16)*sx^3 - (35/16)*sx;

P8 = (35/128) + (6435/128)*sx^8 - (3003/32)*sx^6 + (3465/64)*sx^4 - (315/32)*sx^2; 
 
P9 = (12155/128)*sx^9 - (6435/32)*sx^7 + (9009/64)*sx^5 - (1155/32)*sx^3 + (315/128)*sx;


PList = [P0, P1, P2, P3, P4, P5, P6, P7, P8, P9];



%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% for i=2:(order+1)
% coeffListX1(i) = (coeffListX1(i) * (b-a)/(maxx1-minx1) ) + ((a*maxx1 - b*minx1)/(maxx1 - minx1));
% end
% coeffListX1;
%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



% Recovering the Functions.

PX1 = 0;
for i=0:order
PX1 = PX1 + coeffListX1(i+1) * PList(i+1);
end


PY1 = 0;
for i=0:order
PY1 = PY1 + coeffListY1(i+1) * PList(i+1);
end

% TestX1 = [];
% for i=-1:0.1:1
% TestX1 = [TestX1, subs(PX1,{sx},{i})];
% end
% TestY1 = [];
% for i=-1:0.1:1
% TestY1 = [TestY1, subs(PY1,{sx},{i})];
% end

i = -1:0.1:1;
TestX1 = subs(PX1,{sx},{i});
TestY1 = subs(PY1,{sx},{i});

minTestX1 = min(TestX1);
minTestY1 = min(TestY1);

TestX1 = TestX1 - minTestX1;
TestY1 = TestY1 - minTestY1;


% plot(Stroke1(:,1),Stroke1(:,2))
% 
% figure
% plot(TestX1,TestY1)



