function D = dt(B)
% Last Revised - 21-Nov-2009 
% DT apply Eucledian distance transform
%    D = dt(B) compute the Eucledian distance transform of B
%    B must be a binary map. 
%

[i,j] = find(B);

[n,m] = size(B);
for x = 1:n,
    for y = 1:m,
        dx = i-x;
        dy = j-y;
        dmag = sqrt(dx.*dx+dy.*dy);
	D(x,y) = min(dmag);
    end
end
