function GI = gaussianBlur(I,s)
% Last Revised - 21-Nov-2009
% GAUSSIANBLUR blur the image with a gaussian kernel
%     GI = gaussianBlur(I,s) 
%     I is the image, s is the standard deviation of the gaussian
%     kernel, and GI is the gaussian blurred image.


M = gaussianMask(1,s);
M = M/sum(sum(M));   % normalize the gaussian mask so that the sum is
                     % equal to 1
GI = xconv2(I,M);
