function [Wprofile1, Iprofile1, RecMidPnt, flagDiv,lineMain,lineOther,line1,line2] = laplacianapply(I, BW2, Ordfill, xv, yv, xvp, yvp, bands,  ptel1, ptel2, factor,figflag)

% Author - AKILA MIKE
% This function is the central for all the function / script calls related
% to the Laplacian implementation. Returns the thickness profile.
% factor is control variable 'b' in the paper.

gridsize = size(I);
A2 = ones(gridsize);
A = BW2;


flagDiv = 0;

%whos A2
if(figflag==1)
figure 
imagesc(A);
hold on
end

LblObjBack = bwlabel(A,4);
%RGBObjBack = label2rgb(LblObjBack);
    
    
Bo = A;
    
bt = bwboundaries(Bo,8);
boundary = bt{:};

% Joining all the data points to divide the image into 2 potential levels.

% whos Ordfill
% whos xv
% whos yv
% whos xvp
% whos yvp
tempseg = [Ordfill; xv'  yv'; xvp' yvp'];
lineseg = flipdim(tempseg,2);

%Ordfill

%[xv' yv']

%[xvp' yvp']

%lineseg

yvR = lineseg(:,1);
xvC = lineseg(:,2);

    if(figflag==1)
        plot(xvC,yvR,'*y')
        hold on
        title ('Basic Setup')
    end


for j=1:length(xvC)
    if((yvR(j)>0)&&(xvC(j)>0))
        A2(yvR(j),xvC(j)) = 0;
    end
end

%whos A2
LblLftRgt = bwlabel(A2,4);

Masking = ~logical(LblObjBack);

%whos LblLftRgt
%whos Masking

LblLftRgt = LblLftRgt.* Masking;

boundary(end,:) = []; %Deleting the repetitive entry...
sizeofbound = size(boundary,1);
sizeofline = size(lineseg,1);

% Cut points and there indices (in the boundary) will be stored in the
% following vble names respectively,
% cutpnt, cutpntind
cutpnt = [];
cutpntind = [];

%boundary
exten1 = [xv'  yv'];
exten1 = flipdim(exten1,2);
exten2 = [xvp'  yvp'];
exten2 = flipdim(exten2,2);
sizeofexten1 = size(exten1,1);
sizeofexten2 = size(exten2,1);

% figure
% imshow(I,[])
% hold on
% plot(boundary(:,2),boundary(:,1),'sy')
% hold on

% for k=1:sizeofline
%     k
%     temp = lineseg(k,:)
%     
%     boundary
%     plot(temp(1,2),temp(1,1),'*b')
%     hold on
%     
%     temp = repmat(temp,sizeofbound,1);
%     subres = abs(boundary - temp)
%     subres = sum(subres,2)
%     tempind = find(subres==0);
%     pause
%     % Check if this point is a cut point or not.
%     if (~isempty(tempind))
%         %disp('HURRAH!')
%         cutpnt = [cutpnt; boundary(tempind,:)];
%         cutpntind = [cutpntind; tempind];
%     end    
% end
brkcond1 = 0;
for k=1:sizeofexten1
    if(brkcond1 == 1)
        break;
    end
    %k;
    temp = exten1(k,:);
    
%     boundary
%     plot(temp(1,2),temp(1,1),'*b')
%     hold on
    
    temp = repmat(temp,sizeofbound,1);
    subres = abs(boundary - temp);
    subres = sum(subres,2);
    tempind = find(subres==0);                 
    
    % Check if this point is a cut point or not.
    if (~isempty(tempind))
        %disp('HURRAH!')
        cutpnt = [cutpnt; boundary(tempind(1),:)];
        cutpntind = [cutpntind; tempind(1)];
        brkcond1 = 1;
%         disp('FOUND PERFECT')
    else %Means, there s no exact match - Now look 4 close
        tempindT = find(subres==1);
        if (~isempty(tempindT)) %Have a match 1 pixel offset
            cutpnt = [cutpnt; boundary(tempindT(1),:)];
            cutpntind = [cutpntind; tempindT(1)]; 
            brkcond1 = 1;
%             disp('FOUND CLOSE')
        end
    end 
    
%    pause
end

% disp('OTHER SIDE')
% pause

brkcond2 = 0;
for k=1:sizeofexten1
    if(brkcond2 == 1)
        break;
    end
%     k;
    temp = exten2(k,:);
    
%     boundary
%     plot(temp(1,2),temp(1,1),'*r')
%     hold on
    
    temp = repmat(temp,sizeofbound,1);
    subres = abs(boundary - temp);
    subres = sum(subres,2);
    tempind = find(subres==0);
                   
    % Check if this point is a cut point or not.
    if (~isempty(tempind))
        %disp('HURRAH!')
        cutpnt = [cutpnt; boundary(tempind(1),:)];
        cutpntind = [cutpntind; tempind(1)];
        brkcond2 = 1;
%         disp('FOUND PERFECT')
    else %Means, there s no exact match - Now look 4 close
        tempindT = find(subres==1);
        if (~isempty(tempindT)) %Have a match 1 pixel offset
            cutpnt = [cutpnt; boundary(tempindT(1),:)];
            cutpntind = [cutpntind; tempindT(1)]; 
            brkcond2 = 1;
%             disp('FOUND CLOSE')
        end
    end       
%    pause
end

% disp('DON"T HIT THE ENTER AGAIN')
% pause


% boundary
% lineseg
% cutpnt

%DELETE THIS LATER - 
% figure
% imshow(I,[])
% hold on
% plot(cutpnt(:,2),cutpnt(:,1),'*b')
% hold off
% title('TEST PLOT - CUT POINTS')
% pause

% Checking for the possible number of cut points
if (size(cutpnt,1)~=2)
    h = msgbox('Something s wrong here... Not enough Cutpoints');
end

% Sorting the cutpnts, so that the point higher in the boundary is the
% first...

if (cutpntind(1)>cutpntind(2))
    cutpntind = flipud(cutpntind);
    cutpnt= flipud(cutpnt);
end

% Finding the line segments and storing them in line1, line2

line1 = boundary(cutpntind(1):cutpntind(2),:);
line2 = [boundary(cutpntind(2):sizeofbound,:); boundary(1:cutpntind(1),:)];

line1(1,:) = [];
line1(end,:) = [];
line2(1,:) = [];
line2(end,:) = [];  


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% NEW PART TO ADJUST THE REGION OF INTEREST FOR THE TRACKTHICKNESS FUNC %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sizeL1 = size(line1,1)
sizeL2 = size(line2,1)

sizeTel1 = size(ptel1,1)
sizeTel2 = size(ptel2,1)

%Now Calculate the number of pnts to consider. 

%%%% CHANGED TO NOT REMOVE ANY WIDTH PROFILE INFO %%%%
if (sizeL1 >= sizeL2)
    %disp('Line1 selected')
    NumbPnts = sizeL1 - 2;
    
else
    %disp('Line2 selected')
    NumbPnts = sizeL2 - 2;
end

%NumbPnts = round(((sizeL1+sizeL2)-(sizeTel1+sizeTel2))/2)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if(figflag==1)
    plot(line1(:,2),line1(:,1),'w','linewidth',2)
    hold on
    plot(line2(:,2),line2(:,1),'k','linewidth',2)
    hold off
end

% contstartP2 = line1
% contendP2   = line2

[EucL1] = findEuclength(line1);
[EucL2] = findEuclength(line2);

if (EucL1>=EucL2)
    EucRatio = EucL2/EucL1
else
    EucRatio = EucL1/EucL2
end

%pause

if (EucRatio<0.60)
    flagDiv = 1;
    disp('Problem - The linesegment divides unequally!')
    %Tprofile = 1;
    flagDiv = 1;
    [Wprofile1, Iprofile1, RecMidPnt, lineMain, lineOther] = laplaciansubIntensity(A, I, LblObjBack, LblLftRgt, line1, line2, NumbPnts, factor,figflag);
else
    disp('Divided good enough')
    flagDiv = 0;
    %[Tprofile] = laplaciansub(A, LblObjBack, LblLftRgt, line1, line2);
    %if (bands==1)
    [Wprofile1, Iprofile1, RecMidPnt, lineMain, lineOther] = laplaciansubIntensity(A, I, LblObjBack, LblLftRgt, line1, line2, NumbPnts, factor,figflag);
    %else
        %[Wprofile1, Iprofile1, RecMidPnt] = laplaciansub(A, I, LblObjBack, LblLftRgt, line1, line2, NumbPnts);
    %end
end
    




% BREAK THE SETUP (USING A FLAG RETURN) IF THE RATIO IS SAY LESS THAN 75%.





%save('setupresults.mat', 'A', 'LblObjBack', 'LblLftRgt', 'line1', 'line2');


%Tprofile = 1;