function [X1, Y1, RecMidPnt,lineMain,lineOther] = laplaciansubIntensity(A, I, LblObjBack, LblLftRgt, line1, line2, NumbPnts, factor,figflag)
% Author -  AKILA MIKE
% Date - June 2011
% This function calculates the Laplacian solution for the setup (passed as
% arguments). Also calles the routine to trace the thickness of these line
% segments. - MODIFIED TO CONSIDER INTENSITY BAND INFORMATION AS WELL.

% load setupresults.mat

Threshld = 100;
OldSval  = 0;
iteration = 0;

%factor = 0.99;
%fact2 = 1/(1-factor);
fact2 = (1-factor);

Oneind = (LblLftRgt==1);
Twoind = (LblLftRgt==2);

Aback = A;

[row, col] = size(A);

Dup = abs(I - circshift(I,[1 0]));
Dup = Dup./max(Dup(:));
Dup = 1-Dup;
%Dup = (Dup/fact2)+factor;
Dup = (Dup*fact2)+factor;

Ddw = abs(I - circshift(I,[-1 0]));
Ddw = Ddw./max(Ddw(:));
Ddw = 1-Ddw;
%Ddw = (Ddw/fact2)+factor;
Ddw = (Ddw*fact2)+factor;

Dlf = abs(I - circshift(I,[0 1]));
Dlf = Dlf./max(Dlf(:));
Dlf = 1-Dlf;
%Dlf = (Dlf/fact2)+factor;
Dlf = (Dlf*fact2)+factor;

Drt = abs(I - circshift(I,[0 -1]));
Drt = Drt./max(Drt(:));
Drt = 1-Drt;
%Drt = (Drt/fact2)+factor;
Drt = (Drt*fact2)+factor;

% subplot(2,2,1)
% imshow(Dup,[])
% title('UP')
% subplot(2,2,2)
% imshow(Ddw,[])
% title('DOWN')
% subplot(2,2,3)
% imshow(Dlf,[])
% title('LEFT')
% subplot(2,2,4)
% imshow(Drt,[])
% title('RIGHT')

Dlu = abs(I - circshift(I,[1 1]));
Dlu = Dlu./max(Dlu(:));
Dlu = 1-Dlu;
%Dlu = (Dlu/fact2)+factor;
Dlu = (Dlu*fact2)+factor;

Dld = abs(I - circshift(I,[-1 1]));
Dld = Dld./max(Dld(:));
Dld = 1-Dld;
%Dld = (Dld/fact2)+factor;
Dld = (Dld*fact2)+factor;

Dru = abs(I - circshift(I,[1 -1]));
Dru = Dru./max(Dru(:));
Dru = 1-Dru;
%Dru = (Dru/fact2)+factor;
Dru = (Dru*fact2)+factor;

Drd = abs(I - circshift(I,[-1 -1]));
Drd = Drd./max(Drd(:));
Drd = 1-Drd;
%Drd = (Drd/fact2)+factor;
Drd = (Drd*fact2)+factor;
%circshift(A,[0 1])
%figure
%B = A;

% max(Dup(:))
% 
% min(Dup(:))
% 
% pause

%DELETE THIS SAVE LATER ON...NOT NEEDED. ONLY FOR THE PAPER.
% Savefilen = 'DUPDWN.mat'
% save(Savefilen,'Dup','Ddw','Dlf','Drt','Dlu','Dld','Dru','Drd','A','I')

threshval = 0.0000000001;

disp('Wait!!! Laplacian field is calculating....')

%while (Threshld>=eps)   
while (Threshld>=threshval)
    iteration = iteration + 1;
    
    % enforce boundary conditions
%     A(1,:) = 0;
%     A(gridsize(1),:) = 0;


      A(Oneind) = 1;
      A(Twoind) = 0;
    

    
    % draw what we have
%     if (mod(iteration,100)==0),
%       imagesc(A);
%       colorbar;
%       drawnow;
%     end
    
    % incrementally solve laplace's equation by setting every cell equal
    % to the average value of the neighboring cells    
    
    
    B = 0;
    %C = [];
%     for x=[-1 0 1]
%         for y=[-1 0 1],
%             if (x~=0 || y ~=0),
%                 B = B + circshift(A, [x y]);
%             end
%         end
%     end

    
    %DY = circshift(A,[1 0]) + circshift(A,[-1 0])

    %DX = circshift(A,[0 -1]) + circshift(A,[0 1])
    B = B + Dup.*circshift(A,[1 0]);
    B = B + Ddw.*circshift(A,[-1 0]);
    B = B + Drt.*circshift(A,[0 -1]);
    B = B + Dlf.*circshift(A,[0 1]);
    
    B = B + Dlu.*circshift(A,[1 1]);
    B = B + Dld.*circshift(A,[-1 1]);
    B = B + Dru.*circshift(A,[1 -1]);
    B = B + Drd.*circshift(A,[-1 -1]);
       

%     B = del2(B);
    C = abs(A - B/8);
    %C = abs(A - B/4);
    
    
    %whos 
    %iteration
    Sval = sum(C(:));
    
    Threshld = abs(Sval-OldSval);
    OldSval = Sval;
    
    %pause(0.1)
    %A = B/4;
    A = B/8;
    
end

A(Oneind) = 1;
A(Twoind) = 0;

% figure
% [XC,h] = contour(A,10);
% clabel(XC,h)
% colorbar;
% drawnow;

DY = (circshift(A,[-1 0]) - circshift(A,[1 0]))/2;

DX = (circshift(A,[0 -1]) - circshift(A,[0 1]))/2;

MAGDXY = sqrt((DX.*DX)+(DY.*DY));

NY = DY./MAGDXY;
NX = DX./MAGDXY;

% figure
% imshow(NX,[])
% % imagesc(NX)
% % colorbar;
% % drawnow;
% 
% figure
% imshow(NY,[])
% % imagesc(NY)
% % colorbar;
% % drawnow;

if(figflag==1)
    figure
    %imagesc(I)
    imshow(I,[])
    %imshow(Aback,[])
    hold on
end

[X1, Y1, RecMidPnt,lineMain,lineOther] = tracethickness(A, I, line1, line2, NX, NY, MAGDXY, LblLftRgt, LblObjBack,'Intensity Based Results', NumbPnts,figflag);

if(figflag==1)
    figure
    imshow(I,[])
    hold on
    plot(lineMain(:,2),lineMain(:,1),'*y')
    hold on
    plot(lineOther(:,2),lineOther(:,1),'sb')
    hold off
    title('Contour Point List')
end

%pause