function [Cent,AvgInt,contstartP2,contendP2] = myCentroFind(I,BWT,Ordf,figflag)
%Author - Akila Mike
%Last Modified - 14-DEC-2009
%This function takes in the Image (I), the Binary Result of the GVF Snake
%(BWT) and the Ordered Medial Axis (Ordf) in as inputs and give the
%Eucledian Width of the Chromsome as well as the Avaerage of the
%Intensities as the outputs (Along its Longitudal Axis).

%Implemented a Normal Distribution to Weight the Values of the Avg
%Intensity

% whos I
% max(I(:))
% min(I(:))
% pause

p = pdf('Normal',1:20,0,10);
p = p';

AvgInt = [];
AvgL = [];
nopntside1 = 0;
nopntside2 = 0;
dividefac1 = 0;
dividefac2 = 0;
[LIL] = getinitContour(BWT);
LIf = [LIL(:,2) LIL(:,1)];

if(figflag==1)
    figure            %This was used to Plot the TRELLIS
    imshow(I,[])
    hold on
    plot(LIf(:,1),LIf(:,2))
    hold on
    plot(Ordf(:,1),Ordf(:,2),'r*')
    hold on
end

xvC = Ordf(:,1);
yvC = Ordf(:,2);

sizeL = size(Ordf,1);
Ordf;

sd1LArray = [];
sd2LArray = [];

contstartP2 = [];
contendP2   = [];


%loops from here
for m=1:sizeL-2
    nopntside1 = 0;
    nopntside2 = 0;
    avgside1 = 0;
    avgside2 = 0;    

    stp = m;
    thp = stp+1;
    stp2 = stp+2;  
   
    if((xvC(stp2)-xvC(stp))==0)
        m1 = 0;
    elseif ((yvC(stp2)-yvC(stp))==0)
        m1 = 57;
    else
        m = (yvC(stp2)-yvC(stp))/(xvC(stp2)-xvC(stp));
        m1 = -1/m;
    end
    
    c1 = yvC(thp) - (m1*xvC(thp));
    
    %M and C Calculations are done...

    cryp =  yvC(thp);
    crxp =  xvC(thp);
    
    cryD =  yvC(thp); %Only for Drawing
    crxD =  xvC(thp); %Only for Drawing
    
    %sd1round = 0;
    flag2loop = 1;
    sdLl = 0;
    
    if (abs(m1)<=1)
        xydom = 1; %X is Dominant...
    else
        xydom = 2; %Y is Dominant...
    end       

    TempX = [];
    TempY = [];
    %Another Sub Loop Should Start...For Each Side
        while(flag2loop)
            %sd1round = sd1round+1;
            %Side 1 - Assumming xydom = 1;
            if(xydom == 1)              % X is Dominant
                crx = crxp - 1;
                cry = round((m1*crxp)+c1);
                
                crxD = crx;             %For Display
                cryD = ((m1*crxp)+c1);  %For Display
            else                        % Y is Dominant
                if (m1>=0)
                    cry = cryp - 1;
                    
                    cryD = cry;         %For Display
                else
                    cry = cryp + 1;
                    
                    cryD = cry;         %For Display
                end
                crx = round((cry-c1)/m1);
                
                crxD = ((cry-c1)/m1);
            end                
                

            val = BWT(cry,crx);         %Extracting Values 4m BIN IMAGE
            if(val)                     %Only if not Zero
                nopntside1 = nopntside1 + 1;
                if (nopntside1>19)
                    dividefac1 = 20;
                else
                    dividefac1 = nopntside1;
                end
                
                avgside1 = avgside1+ (I(cry,crx)*p(dividefac1));
                
                TempX = [TempX crxD];
                TempY = [TempY cryD];

                difsum = abs(crx - crxp)+ abs(cry - cryp);
                if(difsum>1)
                    sdLl = sdLl+sqrt(2); 
                else
                    sdLl = sdLl+1;
                end

            else
                flag2loop=0;        
            end  

        crxp = crx;
        cryp = cry;
        end
    sdLl;
    sd1LArray = [sd1LArray;sdLl]; 
    
    contstartP2 = [contstartP2;TempX(end) TempY(end)];

    %sd2round = 0;
    if(figflag==1)
        plot(TempX,TempY,'y','LineWidth',1)
        hold on
    end
    
    %SECOND SIDE STARTS--------------------------->

    TempX2 = [];
    TempY2 = [];
    cryp2 =  yvC(thp);
    crxp2 =  xvC(thp);
    
    cryD2 =  yvC(thp); %Only for Drawing
    crxD2 =  xvC(thp); %Only for Drawing

    sdL2 = 0;
    flag2loop2 = 1;

        while(flag2loop2)
            %sd2round = sd2round+1;
            %Side 1 - Assumming xydom = 1;
%             crx2 = crxp2 + 1;
%             cry2 = round((m1*crxp2)+c1);
            if(xydom == 1) 
                crx2 = crxp2 + 1;
                cry2 = round((m1*crxp2)+c1);
                
                crxD2 = crx2;
                cryD2 = ((m1*crxp2)+c1);                
            else
                if (m1>=0)
                    cry2 = cryp2 + 1;
                    
                    cryD2 = cry2;
                else
                    cry2 = cryp2 - 1;
                    
                    cryD2 = cry2;
                end
                crx2 = round((cry2-c1)/m1);
                
                crxD2 = ((cry2-c1)/m1);
            end

            val = BWT(cry2,crx2);
            if(val)
                nopntside2 = nopntside2 + 1;
                
                if (nopntside2>19)
                    dividefac2 = 20;
                else
                    dividefac2 = nopntside2;
                end
                
                avgside2 = avgside2+(I(cry2,crx2)*p(dividefac2));
                
                TempX2 = [TempX2 crxD2];
                TempY2 = [TempY2 cryD2];

                difsum2 = abs(crx2 - crxp2)+ abs(cry2 - cryp2);
                if(difsum2>1)
                    sdL2 = sdL2+1.432; 
                else
                    sdL2 = sdL2+1;
                end

            else
                flag2loop2=0;        
            end  

        crxp2 = crx2;
        cryp2 = cry2;
        end
    sdL2;
    sd2LArray = [sd2LArray;sdL2];  
    
    AvgL = [AvgL; nopntside1+nopntside2];
    %AvgInt = [AvgInt; (avgside1+avgside2)/(nopntside1+nopntside2)];
    AvgInt = [AvgInt; (avgside1+avgside2)];
 
    
    contendP2 = [contendP2;TempX2(end) TempY2(end)];

    if(figflag==1)
        plot(TempX2,TempY2,'y','LineWidth',1)
        hold on
    end

end
%Loop Ends here
sdLArray = [sd1LArray sd2LArray];



Cent = sum(sdLArray,2);
hold off

% figure
% plot(Cent(:))
% title('Cross Profile')
% grid on
% saveas(gcf,'CrossProfile.tif')
% % 
% figure
% plot(AvgInt(:))
% title('Intensity Profile')
% grid on
% saveas(gcf,'IntensityProfile.tif')










