function [Z] = thintrace(BWthin)
%Author - Akila Mike Subasinghe
%Last modifies - 05-MAR-2010.
%
%When presented with a Binary image with a white (255 / 1) line segment,
%this program detects the end points and then trace it in the proper order.

BWthin = double(BWthin);
elmnt = (ones(3,3));
szR = size(BWthin,1);
posLI = find(BWthin);
posInd = calcNormIndex(posLI,szR);

szmat = size(posInd,1); %The number of locations to check.
SumV = zeros(szmat,1)

for k = 1 : szmat
    Rrange = posInd(k,1) - 1;
    Crange = posInd(k,2) - 1;    
    ExtrMat = BWthin(Rrange:Rrange+2,Crange:Crange+2);
    ResMat = ExtrMat .* elmnt;
    SumV(k,1) = sum(ResMat(:));   
end

LIint = find(SumV==2);

IndInt1 = posInd(LIint(1),:);
IndInt2 = posInd(LIint(2),:);
%C = conv2(double(BWthin),elmnt);

figure
imshow(BWthin,[])
hold on
plot(IndInt1(2),IndInt1(1),'y*')
hold on
plot(IndInt2(2),IndInt2(1),'b*')
hold off
title('Short Chromosome - Thinned')

[ListOrd,Lgaps]=MyGetContour(posInd,IndInt1(1),IndInt1(2),IndInt2(1),IndInt2(2));

% figure
% imshow(BWthin,[])
% hold on
% plot(ListOrd(:,2),ListOrd(:,1),'y')
% title('DID IT WORK?')

Z = [ListOrd(:,2) ListOrd(:,1)];