function [X1, Y1, RecMidPnt,lineMain,lineOther] = tracethickness(A, I, line1, line2, NX, NY, MAGDXY, LblLftRgt, LblObjBack, ttlname, NumbPnts,figflag)
% Author -  AKILA MIKE
% Date - June 2011
% This function calculates the thickness value for each line segment.

% whos A
% max(A(:))
% min(A(:))
% pause

Oneind = (LblLftRgt==1);
Twoind = (LblLftRgt==2);

sizeL1 = size(line1,1);
sizeL2 = size(line2,1);

if (sizeL1 >= sizeL2)
    disp('Line1 selected')
    line = line1;
    %v = round((sizeL1-NumbPnts)/2)
    v = ceil(abs(sizeL1-NumbPnts)/2);
    if(v==0)
        v=1;
    end
    vint = v;
    
else
    disp('Line2 selected')
    line = line2;
    %v = round((sizeL2-NumbPnts)/2)
    v = ceil(abs(sizeL2-NumbPnts)/2);
    if(v==0)
        v=1;
    end
    vint = v;
end

%pause
% ANGS = atan(NY./NX)*(180/pi);

PlaneANGS = NY./NX;
%PlaneANGS2 = NX./NY;

if(figflag==1)
    contour(A,10);
    hold on
    quiver(NX,NY)
    hold on
end

%basefac = floor(sizeL1/4.5);
% basefac = floor(sizeL1/8);
% v = basefac;

%v = 15;
lenList = [];   %Will record Final Length values (Accumulated)
lenListEuc = [];
IntenList = []; %Will record Final Intensity values (Averaged)

RecMidPnt = []; %Record the Mid Points of the line segment

% Big loop for each line segment
%for j=1:(3*basefac)
%for j=1:(round(5.6*basefac))

lineOther = [];

%clc
%pause

for j=1:NumbPnts
    %clc
    %disp('Point number')
    %j
    %disp('%%%%%%%%%%%%')    
    %pause
    
    RecPnts = []; %Will record temp pnts for each segment everytime.
    
    if(figflag==1)
        plot(line(v,2),line(v,1),'sk')
        hold on
    end
    %disp('BIG LOOP NUMBER')
    %j
    len = 0;    %Records the length measurements
    inten = 0;  %Records the Intensity measurements
    numbpnts = 0; %Records the number of points in each segment
    localinten = [];

    Xcor = line(v,2);
    Ycor = line(v,1);
    Xfirst = Xcor;
    Yfirst = Ycor;
    
    %Figuring out which way X and Y should go to (@ Each Point)
    delX = -1;
    delY = -1;
    %j
        
    %Xoutcheck = Xcor - 1;
    if ((LblObjBack(Ycor,Xcor-1)==0)&&(LblObjBack(Ycor,Xcor+1)==1))
        delX = 1;
        %disp('Delta X changed to 1')
    end
    %Youtcheck = Ycor - 1;
    if ((LblObjBack(Ycor-1,Xcor)==0)&&(LblObjBack(Ycor+1,Xcor)==1))
        delY = 1;
        %disp('Delta Y changed to 1')
    end 
    
    if ((LblObjBack(Ycor,Xcor-1)==1)&&(LblObjBack(Ycor,Xcor+1)==1))
        % Big problem - Both sides of X cord is not the edge... 
        % SOLVE LATER - MUST ************************************
        %delX = 1;
    end
    
    if ((LblObjBack(Ycor-1,Xcor)==1)&&(LblObjBack(Ycor+1,Xcor)==1))
        % Big problem - Both sides of Y cord is not the edge... 
        % SOLVE LATER - MUST ************************************
        %delY = 1;
    end

    %Here Starts the loop for one spot on the surface.

    %NANCheck = isnan(ANGS);
    %iterat = 0

    %disp('%%%%%%%%%%%%%%%%%%%%')
    %disp('LOOPING STARTS HERE!')
    %disp('%%%%%%%%%%%%%%%%%%%%')
    
    %Delete this line later
        AngleValLocal = [];
    %----------------------

    %delX = -1;

    %for i=1:3
    %disp('Going into a local loop')
    
    RecPnts = [RecPnts; [Xcor Ycor]];
        
    
    while(1)
        
        %disp('Inside loop Start')
        
        Yold = Ycor
        Xold = Xcor
        ty = NY(round(Ycor),round(Xcor));
        tx = NX(round(Ycor),round(Xcor));
        %abs(PlaneANGS(round(Ycor),round(Xcor)));
        
        if(abs(PlaneANGS(round(Ycor),round(Xcor)))<=1.0)
            %X is the Stepping side
            disp('X is the Stepping side')
            Ycor = Ycor + (PlaneANGS(round(Ycor),round(Xcor)))*delX
            Xcor = Xcor + delX
            
            %New set to solve the multiple point issue.
            if (Ycor>=Yold)
                delY = 1
            else
                delY = -1
            end
            
        else
            %Y is the Stepping side 
            disp('Y is the Stepping side')
            Xcor = Xcor + delY / (PlaneANGS(round(Ycor),round(Xcor)))
            %Xcor = Xcor + delY * (PlaneANGS2(round(Ycor),round(Xcor)));
            Ycor = Ycor + delY
            
            %New set to solve the multiple point issue.
            if (Xcor>=Xold)
                delX = 1
            else
                delX = -1
            end
            
        end
        
%         Ycor = Ycor + (PlaneANGS(round(Ycor),Xcor))*delX;
%         Xcor = Xcor + delX;
        
        %Delete this line later
        AngleValLocal = [AngleValLocal (PlaneANGS(round(Ycor),round(Xcor)))]
        %----------------------
        
        %LblObjBack(round(Ycor),round(Xcor))
        
        %pause
        
        if (LblObjBack(round(Ycor),round(Xcor))==0)
            break;
        end
        %Length and Instensity updates.
        len = len + sqrt((Xold-Xcor).^2+(Yold-Ycor).^2)
        I(round(Ycor),round(Xcor))
        %inten = inten + I(round(Ycor),round(Xcor));
        localinten = [localinten; I(round(Ycor),round(Xcor))]
        
        numbpnts = numbpnts + 1
        if(figflag==1)
            if (mod(j,4)==0)
                plot(Xcor,Ycor,'*y')
                hold on
                %pause
            end

            if (mod(j,4)==1)
                plot(Xcor,Ycor,'dm')
                hold on
                %pause
            end

            if (mod(j,4)==2)
                plot(Xcor,Ycor,'*w')
                hold on
                %pause
            end      
            
            if (mod(j,4)==3)
                plot(Xcor,Ycor,'dr')
                hold on
                %pause
            end 
        end
            
            RecPnts = [RecPnts; [Xcor Ycor]];
            
%     plot(Xcor,Ycor,'*y')
%     hold on

    %disp('Inside loop Ends')    
    %pause
    end
    
    lineOther = [lineOther; RecPnts(end,:)];
    
    RecPntsSz = size(RecPnts,1)
    MidPntsIn = floor(RecPntsSz/2)
    
    if(MidPntsIn>0)
        RecMidPnt = [RecMidPnt; RecPnts(MidPntsIn,:)]
    end
    %disp('Came out of the local loop')
    %end
    %pause
    disp('^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^')
    disp('^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^')
    if (len>=2) %Only record Non-Zero values.
        halfv = floor(numbpnts/2)
        
        if(mod(numbpnts,2))   %Odd number of points
            disp('Odd number of points')
            numbpnts
            %sigv = floor(halfv/3)
            sigv = (halfv/3)
            if(sigv==0)
                sigv = 1;
            end
            p1 = pdf('Normal',-halfv:halfv,0,sigv)'
            sum(p1(:))
            
            TL = localinten.*p1
            
            inten =  sum(TL(:))
            
        else
            disp('Even number of points')
            numbpnts
            %sigv = floor(halfv/3)
            sigv = (halfv/3)
            if(sigv==0)
                sigv = 1;
            end
            p1 = pdf('Normal',-halfv:halfv-1,0,sigv)'
            sum(p1(:))
            
            TL = localinten.*p1
            
            inten =  sum(TL(:))
            
        end
        
        %pause
        
%         localinten = [localinten; I(round(Ycor),round(Xcor))]
%         numbpnts = numbpnts + 1;
        
         lenListEuc = [lenListEuc; sqrt((Xfirst-Xcor).^2+(Yfirst-Ycor).^2)]
         lenList = [lenList;len]
         %IntenList = [IntenList; (inten/numbpnts)];
         IntenList = [IntenList; inten/2]
         %AngleValLocal;
         
         %disp('If statements done')
         %pause
    end
    
    v = v+1
    %disp('One set Done')
    %pause
    
end


lineMain = line(vint:v,:);
lineOther = flipdim(lineOther,2);

%lenList
%lenListEuc
%pause
if(figflag==1)
    title(ttlname)
    hold off
end

if(figflag==1)
    figure
    subplot(2,1,1)
    plot(lenList)
    title(['Length Measurements - ' ttlname])
    subplot(2,1,2)
    plot(IntenList)
    title(['Intensity Measurements - ' ttlname])
end

%sizeL1
%basefac


% sizeL1 = size(line1,1)
% sizeL2 = size(line2,1)


% ANGS(Ycor, Xcor)
% m = tan((ANGS(Ycor, Xcor)*(pi/180)))
% c = (Ycor-m*Xcor)
% 
% Xvals = Xcor:-1:(Xcor-10)
% Yvals = round(m*Xvals + c)
% 
% plot(Xvals(:),Yvals(:),'*r')
% hold on


% while(1)
%     iterat = iterat + 1
%     
%     if (LblObjBack(Ycor,Xcor)==0)
%         break;
%     end
% 
%     Vang = ANGS(Ycor, Xcor)
%     Xdir = NX(Ycor, Xcor)
%     Ydir = NY(Ycor, Xcor)
% 
%         if (Vang>=60.0)
% %             xoff = 0
% %             yoff = 1
%             xoff = 1
%             yoff = 0
%             Loff = 1.0
%         elseif(Vang>=30.0)
%             xoff = 1
%             yoff = 1
%             Loff = 1.414
%         else
% %             xoff = 1
% %             yoff = 0
%             xoff = 0
%             yoff = 1
%             Loff = 1.0
%         end
% 
%         if ((Xdir<0)&&(Ydir<0))
%             xoff = -1*xoff
%             yoff = -1*yoff
%         end
% 
%         if ((Xdir>=0)&&(Ydir<0))
%             %xoff = -1*xoff
%             yoff = -1*yoff
%         end
% 
%         if ((Xdir<0)&&(Ydir>=0))
%             xoff = -1*xoff
%             %yoff = -1*yoff
%         end
% 
%     Xcor = Xcor + xoff
%     Ycor = Ycor + yoff
%     lenght = lenght + Loff
% 
%     plot(Xcor,Ycor,'*r')
%     hold on
%     
%     %pause(10)
%     disp('%%%%%%%%%%%%%%%%%%%%')
% end

X1 = lenList;
Y1 = IntenList;